/*
Simple non code license (SNCL) Version 1.10.0

Copyright (C) 2019 Shouvick Mondal, and Rupesh Nasre.

The original creator(s) of the data or text under this license is thereby
called the licensor.

The person physical or juridical obtaining a copy of the data or text
under this license is thereby called the licensee.

The data or text under this license is therefore called the object.

1. The licensee rights and obligations
1.1. The licensee have the right to obtain a free copy of the object.
1.2. It is a right of the licensee to redistribute unaltered copies of
     the object although commercial use is utterly forbidden
     (except with licensor express written consent).
1.3. The licensee is given the right to adapt or modify the object to
     suit his needs and to redistribute the modified version subject to
     the following conditions:
1.3.1. You must keep the following notice in any copy of the object that
       you may create: Written originally by Shouvick Mondal, and Rupesh Nasre
       on 2019-04-16.
1.3.2. You must keep a changelog somewhere inside the modified object in
       the following format: {version} {YYYY-MM-DD HH:MM (24 hours cycle)}
       {Description} {pages changed list}.
1.3.3. The same rules about commercial use stated in clause 1.1 applies
       here.
1.3.4. You must include the following notice in any object-modified copies
       you redistribute: This document or data is a derivative of Mahtab
       and the information contained here may or may not represent the
       original document or data.
1.3.5. In case of juridical problems that may arise from licensee edits the
       licensee is liable instead of the licensor.
1.4. The licensee is given the right to redistribute work including any
     licensor copyrights originally contained in the object but not to use
     it on its own behalf. (void if the clause 3 is present)
1.5. All of the above clauses are void if the licensee fails to accomplish
     his obligations established in clause 1.
1.6. If the 1.5 clause becomes true the licensee must pay for any costs the
     licensor may have with juridical actions against him.
2. The liability of the licensor
2.1. The licensor is liable only for what himself wrote regarding juridical
     issues related to injury, racism or offense and any other crimes.
2.2. The licensor is not liable for the content that was edited by third
     parties and the liability for such cases falls over the licensee as
     described in 1.3.5.
*/

#include<stdio.h>
#include<cstring>
#include<cmath>
#include<string>
#include<iostream>
#include<stdlib.h>
#include<sys/time.h>
#include<time.h>
#include<omp.h>
#include<set>
#include<algorithm>
#include<iterator>
#include "kmp.cpp"

using namespace std;

#include "buffer_sizes.h"
#include "mytime_per.h"

unsigned long long int test_count,sbound,blk_limit,xpair=1,total_blocks=0,changed_blocks=0,sel_tests=0,seq=0,tf_i=0,tests_failed=0,window=0,windows_failed=0;
struct timeval t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13_1,t13_2,t14_1,t14_2,t15,t16,t17,t18,t19,t20,t21,t22,t23,t24,t25,t26,t27,t28,cs,ce,e1,e2;
int input_mode=0,prioritized=0;

int approach,global_state,ver1,ver2,bench_type;

set<string> globals[2],change_set,escape;

set<unsigned long long int> pos_failed;

float threshold=0.0;

double time0_25=0.0,time0_5=0.0,time1=0.0,time1_5=0.0,time2=0.0,time2_5=0.0,time2_511=0.0,time2_512=0.0,time2_51=0.0,time2_52=0.0,cksum_time=0.0;
double time2_75=0.0,time3=0.0,time3_5=0.0,time3_51=0.0,time3_52=0.0,time3_75=0.0,time4=0.0,time5=0.0,time6=0.0,xtime=0.0;
long double aff_block_per=0.0,sel_test_per=0.0,ecc=0.0,eps=0.0,esc_block_per=0.0;

struct bnode //basic block type
{
	char bname[bnode_bname_size]; //name of basic block
	struct bnode *next;
};

struct map_type //map structure
{
	//FILE *cov; //coverage info file handle
	char cov_fname[map_type_cov_fname_size]; //coverage file name
	struct bnode *block_list; //basic blocks touched upon by the test case {This is stored as singly-linked list}
	//FILE *test; //testcase file handle
	char test_fname[map_type_test_fname_size]; //testfile name
	unsigned long long int is_selected;
	long double rank;
	unsigned long long int id;
}*map; //the map for the whole system

char command[command_size]; //used for commands to system()

char **affected_block; //this stores the names of affected blocks in the program

unsigned long long int b_affected; //count of the affected blocks

void mysystem(char command[],double choice)
{
	//char mycommand[command_size];

	FILE *fp=NULL;

	if(choice==2.511)
	{
		fp=fopen("2511_commands.sh","wt");
		if(fp==NULL)
		{
			printf("Error opening file\n");
			exit(-1);
		}
	}
	else if(choice==2.512)
	{
		fp=fopen("2512_commands.sh","wt");
		if(fp==NULL)
		{
			printf("Error opening file\n");
			exit(-1);
		}
	}
	else
	{
		fp=fopen("commands.sh","wt");
		if(fp==NULL)
		{
			printf("Error opening file\n");
			exit(-1);
		}
	}

	fprintf(fp,"%s",command);

	fclose(fp);

	if(choice==2.511)
	{
		fp=fopen("2511_commands2.sh","wt");
		if(fp==NULL)
		{	
			printf("Error opening file\n");
			exit(-1);
		}
	}
	else if(choice==2.512)
	{
		fp=fopen("2512_commands2.sh","wt");
		if(fp==NULL)
		{	
			printf("Error opening file\n");
			exit(-1);
		}
	}
	else
	{
		fp=fopen("commands2.sh","wt");
		if(fp==NULL)
		{	
			printf("Error opening file\n");
			exit(-1);
		}
	}

	if(choice==2.511)
	{
		fprintf(fp,"#!/bin/bash\n\n");
		fprintf(fp,"TIMEFORMAT=\'cs16d004 %%U shouvick %%S\';\n");
		fprintf(fp,"(time sh ./2511_commands.sh) &> time.tmp.2511;\n");
		fprintf(fp,"grep -e \"cs16d004\" time.tmp.2511 > time.2511;\n");
		fprintf(fp,"rm time.tmp.2511;\n\n");
		fprintf(fp,"exit 0");
		fclose(fp);
	
		system("bash ./2511_commands2.sh");
	
		fp=fopen("time.2511","r");
		if(fp==NULL)
		{
			printf("Error opening file\n");
			exit(-1);
		}
	}
	else if(choice==2.512)
	{
		fprintf(fp,"#!/bin/bash\n\n");
		fprintf(fp,"TIMEFORMAT=\'cs16d004 %%U shouvick %%S\';\n");
		fprintf(fp,"(time sh ./2512_commands.sh) &> time.tmp.2512;\n");
		fprintf(fp,"grep -e \"cs16d004\" time.tmp.2512 > time.2512;\n");
		fprintf(fp,"rm time.tmp.2512;\n\n");
		fprintf(fp,"exit 0");
		fclose(fp);
	
		system("bash ./2512_commands2.sh");
	
		fp=fopen("time.2512","r");
		if(fp==NULL)
		{
			printf("Error opening file\n");
			exit(-1);
		}
	}
	else
	{
		fprintf(fp,"#!/bin/bash\n\n");
		fprintf(fp,"TIMEFORMAT=\'cs16d004 %%U shouvick %%S\';\n");
		fprintf(fp,"(time sh ./commands.sh) &> time.tmp;\n");
		fprintf(fp,"grep -e \"cs16d004\" time.tmp > time;\n");
		fprintf(fp,"rm time.tmp;\n\n");
		fprintf(fp,"exit 0");
		fclose(fp);
	
		system("bash ./commands2.sh");
	
		fp=fopen("time","r");
		if(fp==NULL)
		{
				printf("Error opening file\n");
			exit(-1);
		}
	}

	double val1=0.0,val2=0.0,val3=0.0;

	char s1[15],s2[15];

	fscanf(fp,"%s %lf %s %lf",s1,&val1,s2,&val2);
	
	fclose(fp);

	val3=val1+val2;

	if(choice==0.25)
	{
		time0_25+=val3;
	}
	else if(choice==0.5)
	{
		time0_5+=val3;
	}	
	else if(choice==1.0)
	{
		time1+=val3;
	}
	else if(choice==2.0)
	{
		time2+=val3;
	}
	else if(choice==2.511)
	{
		time2_511+=val3;
	}
	else if(choice==2.512)
	{
		time2_512+=val3;
	}
	else if(choice==2.52)
	{
		time2_52+=val3;
	}
	else if(choice==5.0)
	{
		time5+=val3;	
	}
	else if(choice==6.0)
	{
		time6+=val3;
	}
}

double xmax(double a,double b)
{
	double result;

	if(a<b)
		result=b;
	else
		result=a;

	return(result);
}

int comp_by_rank(const void *x,const void *y)
{
	int retval;

	long double a,b;

	a=((const struct map_type *)x)->rank;
	
	b=((const struct map_type *)y)->rank;

	if(a<b)
		retval=-1;
	else if(a==b)
		retval=0;
	else if(a>b)
		retval=1;

	return(retval);
}

int comp_by_test_id(const void *x,const void *y)
{
	int retval;

	unsigned long long int a,b;

	a=((const struct map_type *)x)->id;
	
	b=((const struct map_type *)y)->id;

	if(a<b)
		retval=-1;
	else if(a==b)
		retval=0;
	else if(a>b)
		retval=1;

	return(retval);
}

void reorder_tests()
{
	qsort(map,test_count,sizeof(struct map_type),comp_by_rank);

	/*for(unsigned long long int i=0;i<test_count;i++)
		printf("\nmap[%llu].rank=%Lf (%s)\n",i,map[i].rank,map[i].test_fname);*/
}

#include "random_rank.cpp"

void prioritize_randomly_all()
{
	srandom(clock());

	#pragma omp parallel for
	for(unsigned long long int i=0;i<test_count;i++)
	{
		map[i].rank=get_random_rank(); //this is a random rank assigned to the test-case
		//printf("\nrank(%s)=%Lf\n",map[i].test_fname,map[i].rank);
	}
}

void prioritize_randomly()
{
	srandom(clock());

	#pragma omp parallel for
	for(unsigned long long int i=0;i<test_count;i++)
	{
		for(unsigned long long int j=0;j<b_affected;j++)
		{
			struct bnode *temp=map[i].block_list;

			while(temp!=NULL)
			{
				if(!strcmp(temp->bname,affected_block[j])) //if match found
				{
					map[i].is_selected=1;
					break;
				}

				temp=temp->next;
			}

			if(map[i].is_selected==1)
				break;
		}

		if(map[i].is_selected==1)
			map[i].rank=get_random_rank(); //this is a random rank assigned to the test-case
		else
			map[i].rank=1.0/0.0;
		
		//printf("\nrank(%s)=%Lf\n",map[i].test_fname,map[i].rank);
	}
}

void prioritize_by_relevance_and_confinedness()
{
	#pragma omp parallel for
	for(unsigned long long int i=0;i<test_count;i++)
	{
		unsigned long long int common=0;
		
		for(unsigned long long int j=0;j<b_affected;j++)
		{
			struct bnode *temp=map[i].block_list;

			while(temp!=NULL)
			{
				if(!strcmp(temp->bname,affected_block[j])) //if match found
				{
					common++;
					map[i].is_selected=1;
					break;
				}

				temp=temp->next;
			}
		}

		if(map[i].is_selected==0)
			map[i].rank=1.0/0.0; //initialize rank to inf

		map[i].rank=(b_affected*1.0)/(common*1.0);

		if(map[i].is_selected==1)
		{
			set<string> cov,add,delta;
			cov.clear();
			add.clear();
			delta=change_set; //delta is defined

			if(bench_type==SEQ_VERSIONS_SED || bench_type==SEQ_VERSIONS_FLEX)
			{			
				set<string> delta1;
				delta1.clear();

				for(set<string>::iterator i=delta.begin(),e=delta.end();i!=e;++i)
				{
					string s="_cs16d004_"+(*i);
					delta1.insert(s);
				}
			
				delta.clear();
				delta=delta1;
			}

			struct bnode *temp=map[i].block_list;

			while(temp!=NULL)
			{
				const char *s=temp->bname;
				string str(s);
				cov.insert(str); //coverage is defined
				temp=temp->next;
			}

			set_difference(cov.begin(),cov.end(),delta.begin(),delta.end(),inserter(add,add.end())); //add=cov-delta

			map[i].rank+=(long double)(add.size()); //rank is defined

			//printf("\nadd:%.2Lf\n",map[i].rank);		
		}
		
		//printf("\nrank(%s)=%Lf\n",map[i].test_fname,map[i].rank);
	}	
}

void prioritize_by_relevance()
{
	#pragma omp parallel for
	for(unsigned long long int i=0;i<test_count;i++)
	{
		unsigned long long int common=0;
			
		for(unsigned long long int j=0;j<b_affected;j++)
		{
			struct bnode *temp=map[i].block_list;
			
			while(temp!=NULL)
			{
				if(!strcmp(temp->bname,affected_block[j])) //if match found
				{
					common++;
					map[i].is_selected=1;
					break;
				}

				temp=temp->next;
			}
		}

		map[i].rank=(b_affected*1.0)/(common*1.0); //this rank is based on relevance and is used for prioritization
		
		//printf("\nrank(%s)=%Lf\n",map[i].test_fname,map[i].rank);
	}
}

void prioritize_by_confinedness()
{
	#pragma omp parallel for
	for(unsigned long long int i=0;i<test_count;i++)
	{
		for(unsigned long long int j=0;j<b_affected;j++)
		{
			struct bnode *temp=map[i].block_list;

			while(temp!=NULL)
			{
				if(!strcmp(temp->bname,affected_block[j])) //if match found
				{
					map[i].is_selected=1;
					break;
				}

				temp=temp->next;
			}

			if(map[i].is_selected==1)
			{
				set<string> cov,add,delta;
				cov.clear();
				add.clear();
				delta=change_set; //delta is defined

				if(bench_type==SEQ_VERSIONS_SED || bench_type==SEQ_VERSIONS_FLEX)
				{			
					set<string> delta1;
					delta1.clear();
	
					for(set<string>::iterator i=delta.begin(),e=delta.end();i!=e;++i)
					{
						string s="_cs16d004_"+(*i);
						delta1.insert(s);
					}
			
					delta.clear();
					delta=delta1;
				}

				temp=map[i].block_list;

				while(temp!=NULL)
				{
					const char *s=temp->bname;
					string str(s);
					cov.insert(str); //coverage is defined
					temp=temp->next;
				}

				set_difference(cov.begin(),cov.end(),delta.begin(),delta.end(),inserter(add,add.end())); //add=cov-delta

				map[i].rank=(long double)(add.size()); //rank is defined

				//printf("\nadd:%.2Lf\n",map[i].rank);		

				break;
			}
		}

		if(map[i].is_selected==0)
			map[i].rank=1.0/0.0; //initialize rank to inf
		
		//printf("\nrank(%s)=%Lf\n",map[i].test_fname,map[i].rank);
	}	
}

void unprioritized()
{
	#pragma omp parallel for
	for(unsigned long long int i=0;i<test_count;i++)
	{
		for(unsigned long long int j=0;j<b_affected;j++)
		{
			struct bnode *temp=map[i].block_list;

			while(temp!=NULL)
			{
				if(!strcmp(temp->bname,affected_block[j])) //if match found
				{
					map[i].is_selected=1;
					break;
				}

				temp=temp->next;
			}

			if(map[i].is_selected==1)
				break;
		}

		if(map[i].is_selected==1)
			map[i].rank=1.0; //this rank is only for considering this test-case
		else
			map[i].rank=1.0/0.0;		
		//printf("\nrank(%s)=%Lf\n",map[i].test_fname,map[i].rank);
	}
}

void selection_all() //selects random prioritization for RetestAll
{
	FILE *rts=NULL;

	rts=fopen("rts.selected","wt");
	if(rts==NULL)
	{
		printf("Error opening rts.selected\n");
		exit(-1);
	}	

	for(unsigned long long int i=0;i<test_count;i++)
	{
		//printf("[%s] ",map[i].test_fname);
		fprintf(rts,"%s\n",map[i].test_fname);		
	}

	fclose(rts);	
}

void selection() //selects only the required testcases
{
	unsigned long long int i,match=0;

	sbound=0;

	/*printf("\naffected blocks: ");

	if(b_affected==0) //if zero diff occured
		printf("NIL");

	for(i=0;i<b_affected;i++)
	{
		printf("(%s) ",affected_block[i]);
	}*/

	long double val=1.0/0.0;

	for(i=0;i<test_count;i++)
	{
		if(map[i].rank==val)
		{
			sbound=i;
			break;
		}
	}

	if(sbound==0)
		sbound=test_count;

	if(gettimeofday(&t7,NULL)<0) //timer4 on
		exit(2);

	if(gettimeofday(&t8,NULL)<0) //timer4 off
		exit(2);

	FILE *rts=NULL;

	rts=fopen("rts.selected","wt");
	if(rts==NULL)
	{
		printf("Error opening rts.selected\n");
		exit(-1);
	}	

	sbound=(threshold/100.0)*sbound; // threshold based reduction
	
	//printf("\n\nselected testcases: ");

	for(i=0;i<sbound;i++)
	{
		if(map[i].is_selected==1)
		{
			match++;
			//printf("[%s] ",map[i].test_fname);
			fprintf(rts,"%s\n",map[i].test_fname);		
		}
	}

	if(match==0) //if nothing is selected
	{
		//printf("NIL");
		fprintf(rts,"NIL");
	}

	//printf("\n\n");

	fclose(rts);

	sel_tests=match;	
}

void populate_block_list() //defines the mapping [code-coverage]<---->[test-case]
{
	/*FILE *fp=NULL;

	fp=fopen("grand.cov","r"); //open coverage file [grand.cov]
	if(fp==NULL)
	{
		printf("error opening file");
		exit(-1);
	}*/

	if(gettimeofday(&t9,NULL)<0) //timer1.5 on
		exit(2);

	#pragma omp parallel for
	for(unsigned long long int i=0;i<test_count;i++)
	{
		FILE *fp=NULL;

		fp=fopen(map[i].cov_fname,"r"); //open coverage file [test_i.cov]
		if(fp==NULL)
		{
			printf("error opening file\n");
			exit(-1);
		}

		char buff[short_buff_size];
		
		map[i].block_list=NULL; //initialize block_list

		struct bnode *temp;

		temp=map[i].block_list;

		while(!feof(fp))
		{
			memset(buff,'\0',short_buff_size);
			fgets(buff,short_buff_size,fp); //read linewise from [.cov] file

			buff[strlen(buff)-1]='\0';

			if(buff[0]=='#')
				break;

			/*if(gettimeofday(&t9,NULL)<0) //timer1.5 on
				exit(2);*/
			
			if(strlen(buff)>=1) //record block names
			{
				if(temp==NULL)
				{
					temp=(struct bnode *)malloc(sizeof(struct bnode));
					strcpy(temp->bname,buff);
					temp->next=NULL;
					map[i].block_list=temp;	
				}
				else 
				{
					struct bnode *new_node=(struct bnode *)malloc(sizeof(struct bnode));
					strcpy(new_node->bname,buff);
					new_node->next=NULL;
					temp->next=new_node;
					temp=new_node;					
				}
			}

			/*if(gettimeofday(&t10,NULL)<0) //timer1.5 off
				exit(2);

			time1_5+=((t10.tv_sec*1000000+t10.tv_usec)-(t9.tv_sec*1000000+t9.tv_usec))/1000000.0;*/
		}

		fclose(fp); //close [test_i.cov] file	
	}

	if(gettimeofday(&t10,NULL)<0) //timer1.5 off
		exit(2);
	
	time1_5=((t10.tv_sec*1000000+t10.tv_usec)-(t9.tv_sec*1000000+t9.tv_usec))/1000000.0;

	//fclose(fp); //close [grand.cov] file	
}

void display_map() //displays the mapping [code-coverage]<---->[test-case]
{
	unsigned long long int i;

	struct bnode *temp;

	for(i=0;i<test_count;i++)
	{
		printf("\n{%s.cov}<------>{%s}\n",map[i].test_fname,map[i].test_fname);
		
		temp=map[i].block_list;
		
		printf("basic blocks covered by [%s]: ",map[i].test_fname);

		while(temp!=NULL)
		{
			printf("(%s) ",temp->bname);
			temp=temp->next;
		}

		printf("\n");
	}
}

int validate(char source[],char testname[],double choice) //compares current output with expected output and reports appropriate outcome
{
	int result=-1;

	char mycommand[command_size];
	memset(mycommand,'\0',command_size);
	sprintf(mycommand,"diff expected_out/%s.output current_out/%s.output | wc -c > test.result",testname,testname);
	mysystem(mycommand,choice);
	
	FILE *fp=NULL;

	fp=fopen("test.result","r");
	if(fp==NULL)
	{
		printf("Error opening test.result\n");
		exit(-1);
	}

	fscanf(fp,"%d",&result);

	fclose(fp);

	return(result);
}

int validate_par(char source[],char testname[]) //compares current output with expected output and reports appropriate outcome
{
	int result=-1;

	char mycommand[command_size];
	memset(mycommand,'\0',command_size);
	sprintf(mycommand,"diff expected_out/%s.output current_out/%s.output | wc -c > %s.result",testname,testname,testname);
	system(mycommand);

	char name[test_name_size];

	sprintf(name,"%s.result",testname);
	
	FILE *fp=NULL;

	fp=fopen(name,"r");
	if(fp==NULL)
	{
		printf("Error opening test.result\n");
		exit(-1);
	}

	fscanf(fp,"%d",&result);

	fclose(fp);

	return(result);
}

void runSelected(char source[],int v2) //runs selected tests only
{
	if(approach==ALL)
		sel_tests=test_count;

	unsigned long long int left=sel_tests,rounds=(unsigned long long int)ceil((double)sel_tests/(double)window);

	seq=0;

	tf_i=0;

	pos_failed.clear();

	FILE *rts=NULL;

	char buff[short_buff_size],buff1[short_buff_size];
	char mycommand[command_size];

	if(bench_type==SEQ_VERSIONS)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -DSTDC_HEADERS=1 -DHAVE_UNISTD_H=1 -DDIRENT=1 -DHAVE_ALLOCA_H=1 -DHAVE_CONFIG_H -I. v%d/%s.c -lm -o exe",v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_GIT)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -std=gnu99 -fgnu89-inline -fPIC -Iv%d/src v%d/src/*.c v%d/%s.c -lm -o exe",v2,v2,v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_SCD)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -Iv%d/lib v%d/lib/*.c v%d/%s.c -o exe",v2,v2,v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_C4)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -m32 -Wno-return-type v%d/%s.c -o exe -Wl,--no-as-needed -ldl",v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_CF)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -g -Wall -Iv%d v%d/mozilla-sha1/*.c v%d/cuckoo_filter.c v%d/%s.c -o exe",v2,v2,v2,v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_MLISP)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 v%d/%s.c -o exe",v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_GREP)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -Iv%d v%d/%s.c -lm -o exe",v2,v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_SED)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -std=c99 v%d/%s.c -o exe",v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_FLEX)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -DHAVE_ALLOCA_H=1 v%d/%s.c -o exe",v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==MUT_VERSIONS)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -std=c99 v%d/%s.c -lm -o exe",v2,source);
		mysystem(mycommand,5.0);
	}

	if(approach==ALL)
	{
		if(prioritized==2)
		{
			selection_all();	
		}
		else
		{		
			memset(mycommand,'\0',command_size);
			sprintf(mycommand,"cat tests.db > rts.selected");
			system(mycommand);
		}
	}

	rts=fopen("rts.selected","r");
	if(rts==NULL)
	{
		printf("Error opening rts.selected\n");
		exit(-1);
	}

	char **com_arr,**buff_fail,**com_buff;

	com_arr=(char**)malloc(window*sizeof(char*));       /*dynamic memory allocation*/
	buff_fail=(char**)malloc(window*sizeof(char*));     /*dynamic memory allocation*/
	com_buff=(char**)malloc(window*sizeof(char*));      /*dynamic memory allocation*/
    	
	unsigned long long int j,*fail,last_count=0;

	fail=(unsigned long long int*)malloc(window*sizeof(unsigned long long int));  /*dynamic memory allocation*/
	
	for(j=0;j<window;j++)
    {
    	com_arr[j]=(char*)malloc(command_size*sizeof(char));
		buff_fail[j]=(char*)malloc(short_buff_size*sizeof(char));
		com_buff[j]=(char*)malloc(short_buff_size*sizeof(char));
		fail[j]=0;
    }

	j=0;

	time5=0.0;

	while(fscanf(rts,"%s",buff)!=EOF)
	{
		if(mystrstr(buff,"NIL")>0)
			break;

		char mychar[long_buff_size];

		memset(mychar,'\0',long_buff_size);

		memset(buff1,'\0',short_buff_size);

		strcpy(buff1,"testcases/");

		strcat(buff1,buff);

		FILE *fp=NULL;

		fp=fopen(buff1,"r");
		if(fp==NULL)
		{
			printf("Error opening file\n");
			exit(-1);
		}

		fscanf(fp,"%[^\n]s",mychar);

		fclose(fp);

		memset(mycommand,'\0',command_size);

		if(bench_type==SEQ_VERSIONS || bench_type==SEQ_VERSIONS_GREP || bench_type==SEQ_VERSIONS_SED)
		{
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output 2>&1",mychar,buff);
			}		
			else if(input_mode==SCAN_ONLY_DIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output 2>&1",buff1,buff);
			}
			else if(input_mode==COMMAND_LINE_SCAN)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output 2>&1",mychar,buff);
			}
			else if(input_mode==SCAN_ONLY_INDIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output 2>&1",mychar,buff);
			}
		}
		else if(bench_type==SEQ_VERSIONS_GIT || bench_type==SEQ_VERSIONS_C4 || bench_type==SEQ_VERSIONS_SCD)
		{
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}		
			else if(input_mode==SCAN_ONLY_DIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output",buff1,buff);
			}
				else if(input_mode==COMMAND_LINE_SCAN)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}
			else if(input_mode==SCAN_ONLY_INDIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output",mychar,buff);
			}
		}
		else if(bench_type==SEQ_VERSIONS_CF)
		{
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s current_out/%s.output >> current_out/%s.output",mychar,buff,buff);
			}		
		}
		else if(bench_type==SEQ_VERSIONS_MLISP)
		{
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}		
		}
		else if(bench_type==SEQ_VERSIONS_FLEX)
		{
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output 2>&1;cat lex.yy.c >> current_out/%s.output;cat lex.backup >> current_out/%s.output;cat error >> current_out/%s.output",mychar,buff,buff,buff,buff);
			}		
			else if(input_mode==SCAN_ONLY_DIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output 2>&1;cat lex.yy.c >> current_out/%s.output;cat lex.backup >> current_out/%s.output;cat error >> current_out/%s.output",buff1,buff,buff,buff,buff);
			}
			else if(input_mode==COMMAND_LINE_SCAN)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output 2>&1;cat lex.yy.c >> current_out/%s.output;cat lex.backup >> current_out/%s.output;cat error >> current_out/%s.output",mychar,buff,buff,buff,buff);
			}
			else if(input_mode==SCAN_ONLY_INDIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output 2>&1;cat lex.yy.c >> current_out/%s.output;cat lex.backup >> current_out/%s.output;cat error >> current_out/%s.output",mychar,buff,buff,buff,buff);
			}
		}
		else if(bench_type==MUT_VERSIONS)
		{
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}		
			else if(input_mode==SCAN_ONLY_DIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output",buff1,buff);
			}
			else if(input_mode==COMMAND_LINE_SCAN)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}
			else if(input_mode==SCAN_ONLY_INDIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output",mychar,buff);
			}
		}

		strcpy(com_arr[j],mycommand);
		strcpy(com_buff[j],buff);

		j++;

		if(rounds>1 && j==window)
		{
			seq++;
			
			rounds--;

			j=0;

			unsigned long long int window_failed=0;

			if(gettimeofday(&e1,NULL)<0) //timer5 on
				exit(2);

			#pragma omp parallel for num_threads(window)
			for(unsigned long long int k=0;k<window;k++)
			{
				system(com_arr[k]);	

				if(validate_par(source,com_buff[k])!=0)
				{	
					sprintf(buff_fail[k],"[v%d/%s.c] testcase (%s) failed\n\n",v2,source,com_buff[k]);
					fail[k]++;
				}
			}

			if(gettimeofday(&e2,NULL)<0) //timer5 off
				exit(2);

			time5+=((e2.tv_sec*1000000+e2.tv_usec)-(e1.tv_sec*1000000+e1.tv_usec))/1000000.0; //parallel execution time

			for(unsigned long long int k=0;k<window;k++)
			{
				if(fail[k]!=0)
				{
					printf("%s",buff_fail[k]);
					tests_failed++;
					window_failed++;
				}

				fail[k]=0; //clear for next round
				left--;
			}

			if(window_failed>0)
			{
				windows_failed++;
				pos_failed.insert(seq);
			}
		}
		
		if(rounds==1)
		{
			if(left>0)
			{	
				last_count++;
				left--;
				continue;
			}			
			
			if(left==0)
			{
				seq++;
			
				rounds--;

				j=0;

				unsigned long long int window_failed=0;

				if(gettimeofday(&e1,NULL)<0) //timer5 on
					exit(2);
	
				#pragma omp parallel for num_threads(last_count)
				for(unsigned long long int k=0;k<last_count;k++)
				{
					system(com_arr[k]);	
	
					if(validate_par(source,com_buff[k])!=0)
					{	
						sprintf(buff_fail[k],"[v%d/%s.c] testcase (%s) failed\n\n",v2,source,com_buff[k]);
						fail[k]++;
					}
				}
	
				if(gettimeofday(&e2,NULL)<0) //timer5 off
					exit(2);
	
				time5+=((e2.tv_sec*1000000+e2.tv_usec)-(e1.tv_sec*1000000+e1.tv_usec))/1000000.0; //parallel execution time
	
				for(unsigned long long int k=0;k<last_count;k++)
				{
					if(fail[k]!=0)
					{
						printf("%s",buff_fail[k]);
						tests_failed++;
						window_failed++;
					}
	
					fail[k]=0; //clear for next round
				}
	
				if(window_failed>0)
				{
					windows_failed++;
					pos_failed.insert(seq);
				}
				
			}	
		}
	}	
	
	fclose(rts);

	for(j=0;j<window;j++)
   		free(com_arr[j]);
   		
	free(com_arr);

	for(j=0;j<window;j++)
   		free(buff_fail[j]);
   		
	free(buff_fail);

	for(j=0;j<window;j++)
   		free(com_buff[j]);
   		
	free(com_buff);
	free(fail);
}

void runAll(char source[],int v2) //runs all the tests
{
	FILE *all=NULL;

	char buff[short_buff_size],buff1[short_buff_size];
	char mycommand[command_size];

	if(bench_type==SEQ_VERSIONS)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -DSTDC_HEADERS=1 -DHAVE_UNISTD_H=1 -DDIRENT=1 -DHAVE_ALLOCA_H=1 -DHAVE_CONFIG_H -I. v%d/%s.c -lm -o exe",v2,source);
		mysystem(mycommand,6.0);
	}
	else if(bench_type==SEQ_VERSIONS_GIT)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -std=gnu99 -fgnu89-inline -fPIC -Iv%d/src v%d/src/*.c v%d/%s.c -lm -o exe",v2,v2,v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_C4)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -m32 -Wno-return-type v%d/%s.c -o exe -Wl,--no-as-needed -ldl",v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_GREP)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -Iv%d v%d/%s.c -lm -o exe",v2,v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_SED)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -std=c99 v%d/%s.c -o exe",v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==SEQ_VERSIONS_FLEX)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -DHAVE_ALLOCA_H=1 v%d/%s.c -o exe",v2,source);
		mysystem(mycommand,5.0);
	}
	else if(bench_type==MUT_VERSIONS)
	{
		memset(mycommand,'\0',command_size);
		sprintf(mycommand,"gcc -O3 -std=c99 v%d/%s.c -lm -o exe",v2,source);
		mysystem(mycommand,6.0);
	}

	all=fopen("tests.db","r");
	if(all==NULL)
	{
		printf("Error opening tests.db\n");
		exit(-1);
	}

	while(fscanf(all,"%s",buff)!=EOF)
	{
		char mychar[long_buff_size];

		memset(mychar,'\0',long_buff_size);

		memset(buff1,'\0',short_buff_size);

		strcpy(buff1,"testcases/");

		strcat(buff1,buff);

		FILE *fp=NULL;

		fp=fopen(buff1,"r");
		if(fp==NULL)
		{
			printf("Error opening file\n");
			exit(-1);
		}

		fscanf(fp,"%[^\n]s",mychar);

		fclose(fp);

		memset(mycommand,'\0',command_size);

		if(bench_type==SEQ_VERSIONS || bench_type==SEQ_VERSIONS_GREP || bench_type==SEQ_VERSIONS_SED)
		{		
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output 2>&1",mychar,buff);
			}			
			else if(input_mode==SCAN_ONLY_DIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output 2>&1",buff1,buff);
			}
			else if(input_mode==COMMAND_LINE_SCAN)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output 2>&1",mychar,buff);
			}
			else if(input_mode==SCAN_ONLY_INDIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output 2>&1",mychar,buff);
			}
		}
		else if(bench_type==SEQ_VERSIONS_GIT || bench_type==SEQ_VERSIONS_C4)
		{		
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}			
			else if(input_mode==SCAN_ONLY_DIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output",buff1,buff);
			}
			else if(input_mode==COMMAND_LINE_SCAN)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}
			else if(input_mode==SCAN_ONLY_INDIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output",mychar,buff);
			}
		}
		else if(bench_type==SEQ_VERSIONS_FLEX)
		{
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output 2>&1;cat lex.yy.c >> current_out/%s.output;cat lex.backup >> current_out/%s.output;cat error >> current_out/%s.output",mychar,buff,buff,buff,buff);
			}		
			else if(input_mode==SCAN_ONLY_DIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output 2>&1;cat lex.yy.c >> current_out/%s.output;cat lex.backup >> current_out/%s.output;cat error >> current_out/%s.output",buff1,buff,buff,buff,buff);
			}
			else if(input_mode==COMMAND_LINE_SCAN)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output 2>&1;cat lex.yy.c >> current_out/%s.output;cat lex.backup >> current_out/%s.output;cat error >> current_out/%s.output",mychar,buff,buff,buff,buff);
			}
			else if(input_mode==SCAN_ONLY_INDIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output 2>&1;cat lex.yy.c >> current_out/%s.output;cat lex.backup >> current_out/%s.output;cat error >> current_out/%s.output",mychar,buff,buff,buff,buff);
			}
		}
		else if(bench_type==MUT_VERSIONS)
		{		
			if(input_mode==COMMAND_LINE_ONLY)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}			
			else if(input_mode==SCAN_ONLY_DIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output",buff1,buff);
			}
			else if(input_mode==COMMAND_LINE_SCAN)
			{
				sprintf(mycommand,"./exe %s > current_out/%s.output",mychar,buff);
			}
			else if(input_mode==SCAN_ONLY_INDIRECT)
			{
				sprintf(mycommand,"./exe < %s > current_out/%s.output",mychar,buff);
			}
		}	

		mysystem(mycommand,6.0);	

		if(validate(source,buff,6.0)!=0)
		{
			printf("[v%d/%s.c] testcase (%s) failed\n\n",v2,source,buff);		
		}
	}

	fclose(all);
}

#include "sys_write.cpp"
#include "sminstru.cpp"
#include "smdiff.cpp"
#include "apfd.cpp"
#include "ecc.cpp"
#include "epsilon.cpp"
#include "free_map.cpp"

int main(int argc,char *argv[]) //analysis-engine entry point
{
	//---------------------------------------------------------------Begin Initializations-----------------------------------------------------------------

	/*
        prioritization flags:
       -----------------------
		0: No prioritization
		1: Prioritize by relevance
		2: Prioritize randomly
		3: Prioritize by confinedness
		4: Prioritize by relevance and confinedness
	*/
	
	if(argc<8)
	{
		printf("\n Usage: ./engine [#tests] [input_mode] [global_sensitivity] [prioritization] [threshold in %%] [window_size] [time_dump]\n");
		printf("\n {input_mode} flags:\n"
		" -------------------\n"
		" 111: Command line only (command line)\n"
		" 222: Scan only direct (direct input from file)\n"
		" 333: Command line scan (command line and file)\n"
		" 444: Scan only indirect (indirect input from file)\n");
		printf("\n {global_sensitivity} flags:\n"
		" ---------------------------\n"
		" 11: On (analyze global segment)\n"
		" 22: Off (do not analyze global segment)\n");
		printf("\n {prioritization} flags:\n"
        " -----------------------\n"
		" 0: No prioritization (untreated)\n"
		" 1: Prioritize by relevance (strength of affected-blocks coverage)\n"
		" 2: Prioritize randomly (random prioritization)\n"
		" 3: Prioritize by confinedness (change-impact localization)\n"
		" 4: Prioritize by relevance and confinedness (combination of 1 and 3 with \'+\' operator)\n\n");
		exit(-1);
	}

	test_count=atoll(argv[1]);

	input_mode=atoi(argv[2]);

	global_state=atoi(argv[3]);

	prioritized=atoi(argv[4]);

	threshold=atof(argv[5]);

	window=atoll(argv[6]);

	//double rts_tot=0.0,all_tot=0.0;

	char t_buff[test_name_size];
	char c_source[c_source_fname_size];
	//char llvm_ir_diff[llvm_ir_diff_size]; //used for recording the diff info at the LLVM IR level
	
	unsigned long long int i;

	/*map=(struct map_type*)malloc(test_count*sizeof(struct map_type)); //allocate map accordingly

	//#pragma omp parallel for
	for(unsigned long long int i=0;i<test_count;i++) //initialize map
	{
		map[i].cov=NULL; //initialize FILE pointers
		map[i].test=NULL; 
		map[i].is_selected=0; //initialize selection status
		map[i].rank=0.0;
	}

	memset(c_source,'\0',c_source_fname_size);
	memset(c_source_mod1,'\0',c_source_mod1_fname_size);

	FILE *tdb=fopen("tests.db","r"); //open [tests.db]
	if(tdb==NULL)
	{
		printf("Error opening test database");
		exit(-1);
	}

	i=0;

	while(!feof(tdb))
	{
		memset(t_buff,'\0',test_name_size);
		fgets(t_buff,test_name_size,tdb);
		unsigned long long int len_test=strlen(t_buff);
		t_buff[len_test-1]='\0'; //discard '\n'
		
		if(len_test>=3 && mystrstr(t_buff,".txt")>0)
		{
			strcpy(map[i].test_fname,t_buff);
			i++;
		}
	}

	fclose(tdb); //close [tests.db]
	*/
	//memset(llvm_ir_diff,'\0',llvm_ir_diff_size); //clear diff_buffer

	FILE *bench=NULL;

	bench=fopen("bench","r");
	if(bench==NULL)
	{
		printf("Error opening bench file\n");
		exit(-1);
	}

	fscanf(bench,"%d",&bench_type);
	fclose(bench);

	FILE *ver=NULL;

	ver=fopen("versions","r");
	if(ver==NULL)
	{
		printf("Error opening versions\n");
		exit(-1);
	}	

	FILE *stats=NULL;

	stats=fopen("report","a");
	if(stats==NULL)
	{
		printf("Error opening stats\n");
		exit(-1);
	}	

	while(fscanf(ver,"%s %d %d",c_source,&ver1,&ver2)!=EOF)
	{
		/*sprintf(file1,"v%d/%s",ver1,c_source);
		sprintf(file2,"v%d/%s",ver2,c_source);*/	

		time0_25=0.0,time0_5=0.0,time1=0.0,time1_5=0.0,time2=0.0,time2_5=0.0,time2_511=0.0,time2_512=0.0,time2_51=0.0,time2_52=0.0;
		time2_75=0.0,time3=0.0,time3_5=0.0,time3_51=0.0,time3_52=0.0,time3_75=0.0,time4=0.0,time5=0.0,time6=0.0,xtime=0.0;

		total_blocks=0;
		changed_blocks=0;
		sel_tests=0;
		ecc=0.0;
		tests_failed=0;
		escape.clear();

		//if(xpair==1)
		{	
			map=(struct map_type*)malloc(test_count*sizeof(struct map_type)); //allocate map accordingly

			//#pragma omp parallel for
			for(i=0;i<test_count;i++) //initialize map
			{
				//map[i].cov=NULL; //initialize FILE pointers
				//map[i].test=NULL; 
				map[i].is_selected=0; //initialize selection status
				map[i].rank=0.0;
				map[i].id=i+1; //initialize test-case id
			}

			FILE *tdb=fopen("tests.db","r"); //open [tests.db]
			if(tdb==NULL)
			{
				printf("Error opening test database\n");
				exit(-1);
			}

			i=0;

			while(!feof(tdb))
			{
				memset(t_buff,'\0',test_name_size);
				fgets(t_buff,test_name_size,tdb);
				unsigned long long int len_test=strlen(t_buff);
				t_buff[len_test-1]='\0'; //discard '\n'
		
				if(len_test>=3 && mystrstr(t_buff,".txt")>0)
				{
					strcpy(map[i].test_fname,t_buff);
					sprintf(map[i].cov_fname,"%s.cov",map[i].test_fname); // added on 21/06/2018
					i++;
				}
			}

			fclose(tdb); //close [tests.db]

			//---------------------------------------------------------------End Initializations-----------------------------------------------------------------

			sminstru(c_source); //timers 0.25 and 0.5 are here

			//---------------------------------------------------------------Begin Map Learning------------------------------------------------------------------

			if(gettimeofday(&t1,NULL)<0) //timer1 on
				exit(2);

			#pragma omp parallel for
			for(unsigned long long int i=0;i<test_count;i++) //generate coverage information [.cov file] for each testcase
			{
				char mycommand[command_size];

				memset(mycommand,'\0',command_size);

				char mychar[long_buff_size],buff1[short_buff_size];

				memset(mychar,'\0',long_buff_size);

				FILE *fp=NULL;

				memset(buff1,'\0',short_buff_size);

				strcpy(buff1,"testcases/");

				strcat(buff1,map[i].test_fname);

				fp=fopen(buff1,"r");
				if(fp==NULL)
				{
					printf("Error opening file\n");
					exit(-1);
				}

				fscanf(fp,"%[^\n]s",mychar);

				fclose(fp);

				if(bench_type==SEQ_VERSIONS || bench_type==SEQ_VERSIONS_GREP)
				{
					if(TEST_GEN==0)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s >&1 | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
						else if(input_mode==SCAN_ONLY_DIRECT)
						{
							sprintf(mycommand,"./a.out < %s >&1 | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",buff1,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==COMMAND_LINE_SCAN)
						{
							sprintf(mycommand,"./a.out %s >&1 | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==SCAN_ONLY_INDIRECT)
						{
							sprintf(mycommand,"./a.out < %s >&1 | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
					}					
					else if(TEST_GEN==1)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s >&1 >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
						else if(input_mode==SCAN_ONLY_DIRECT)
						{
							sprintf(mycommand,"./a.out < %s >&1 | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",buff1,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==COMMAND_LINE_SCAN)
						{
							sprintf(mycommand,"./a.out %s >&1 >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==SCAN_ONLY_INDIRECT)
						{
							sprintf(mycommand,"./a.out < %s >&1 | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
					}
				}
				else if(bench_type==SEQ_VERSIONS_GIT || bench_type==SEQ_VERSIONS_C4 || bench_type==SEQ_VERSIONS_SCD)
				{
					if(TEST_GEN==0)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
						else if(input_mode==SCAN_ONLY_DIRECT)
						{
							sprintf(mycommand,"./a.out < %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",buff1,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==COMMAND_LINE_SCAN)
						{
							sprintf(mycommand,"./a.out %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==SCAN_ONLY_INDIRECT)
						{
							sprintf(mycommand,"./a.out < %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
					}					
					else if(TEST_GEN==1)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
						else if(input_mode==SCAN_ONLY_DIRECT)
						{
							sprintf(mycommand,"./a.out < %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",buff1,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==COMMAND_LINE_SCAN)
						{
							sprintf(mycommand,"./a.out %s >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==SCAN_ONLY_INDIRECT)
						{
							sprintf(mycommand,"./a.out < %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
					}
				}
				else if(bench_type==SEQ_VERSIONS_CF)
				{
					if(TEST_GEN==0)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s %s.cftemp | awk '!seen[$0]++' >> %s; echo \"#\" >> %s;rm %s.cftemp",mychar,map[i].test_fname,map[i].cov_fname,map[i].cov_fname,map[i].test_fname);
						}		
					}					
				}
				else if(bench_type==SEQ_VERSIONS_MLISP)
				{
					if(TEST_GEN==0)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
					}					
				}
				else if(bench_type==SEQ_VERSIONS_SED || bench_type==SEQ_VERSIONS_FLEX)
				{
					if(TEST_GEN==0)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s >&1 | awk '!seen[$0]++' | grep -e \"_cs16d004_\" >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
						else if(input_mode==SCAN_ONLY_DIRECT)
						{
							sprintf(mycommand,"./a.out < %s >&1 | awk '!seen[$0]++' | grep -e \"_cs16d004_\" >> %s; echo \"#\" >> %s",buff1,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==COMMAND_LINE_SCAN)
						{
							sprintf(mycommand,"./a.out %s >&1 | awk '!seen[$0]++' | grep -e \"_cs16d004_\" >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==SCAN_ONLY_INDIRECT)
						{
							sprintf(mycommand,"./a.out < %s >&1 | awk '!seen[$0]++' | grep -e \"_cs16d004_\" >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
					}					
					else if(TEST_GEN==1)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s >&1 | grep -e \"_cs16d004_\" >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
						else if(input_mode==SCAN_ONLY_DIRECT)
						{
							sprintf(mycommand,"./a.out < %s >&1 | awk '!seen[$0]++' | grep -e \"_cs16d004_\" >> %s; echo \"#\" >> %s",buff1,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==COMMAND_LINE_SCAN)
						{
							sprintf(mycommand,"./a.out %s >&1 | grep -e \"_cs16d004_\" >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==SCAN_ONLY_INDIRECT)
						{
							sprintf(mycommand,"./a.out < %s >&1 | awk '!seen[$0]++' | grep -e \"_cs16d004_\" >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
					}
				}
				else if(bench_type==MUT_VERSIONS)
				{
					if(TEST_GEN==0)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
						else if(input_mode==SCAN_ONLY_DIRECT)
						{
							sprintf(mycommand,"./a.out < %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",buff1,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==COMMAND_LINE_SCAN)
						{
							sprintf(mycommand,"./a.out %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==SCAN_ONLY_INDIRECT)
						{
							sprintf(mycommand,"./a.out < %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
					}					
					else if(TEST_GEN==1)
					{
						if(input_mode==COMMAND_LINE_ONLY)
						{
							sprintf(mycommand,"./a.out %s >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}		
						else if(input_mode==SCAN_ONLY_DIRECT)
						{
							sprintf(mycommand,"./a.out < %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",buff1,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==COMMAND_LINE_SCAN)
						{
							sprintf(mycommand,"./a.out %s >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
						else if(input_mode==SCAN_ONLY_INDIRECT)
						{
							sprintf(mycommand,"./a.out < %s | awk '!seen[$0]++' >> %s; echo \"#\" >> %s",mychar,map[i].cov_fname,map[i].cov_fname);
						}
					}
				}

				//mysystem(mycommand,1.0);
				system(mycommand);

				/*memset(mycommand,'\0',command_size);
				sprintf(mycommand,"%s.cov",map[i].test_fname);	
				strcpy(map[i].cov_fname,mycommand);*/
			}

			if(gettimeofday(&t2,NULL)<0) //timer1 off
				exit(2);		

			populate_block_list(); //record block coverage info in map

			//---------------------------------------------------------------End Map Learning--------------------------------------------------------------------

			//display_map(); //show map

		}
		/*else
		{
			#pragma omp parallel for
			for(i=0;i<test_count;i++) //initialize map
			{
				map[i].is_selected=0; //initialize selection status
				map[i].rank=0.0;
			}

			qsort(map,test_count,sizeof(struct map_type),comp_by_test_id); //refresh map for next iteration
		}*/
			//--------------------------------------------------------------Begin Generate DIFF------------------------------------------------------------------

		/*if(pair>1)
		{
			memset(command,'\0',command_size);
			sprintf(command,"clang -std=c99 -lm -O0 -S -emit-llvm -Wno-implicit-int -Wno-return-type %s.c",c_source); //generate LLVM IR for the modified source
			system(command);
		}*/

		if(bench_type==SEQ_VERSIONS)
		{		
			memset(command,'\0',command_size);
			sprintf(command,"clang -DSTDC_HEADERS=1 -DHAVE_UNISTD_H=1 -DDIRENT=1 -DHAVE_ALLOCA_H=1 -DHAVE_CONFIG_H -I. -lm -O0 -S -emit-llvm -Wno-implicit-int -Wno-return-type v%d/%s.c -o %s_v%d.ll",ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}
		else if(bench_type==SEQ_VERSIONS_GIT)
		{		
			memset(command,'\0',command_size);
			sprintf(command,"cd v%d;clang -std=gnu99 -fgnu89-inline -fPIC -Isrc src/*.c -S -O0 -emit-llvm %s.c -lm; llvm-link -S *.ll -o ../%s_v%d.ll;cd ..",ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}
		else if(bench_type==SEQ_VERSIONS_SCD)
		{		
			memset(command,'\0',command_size);
			sprintf(command,"cd v%d;clang -S -O0 -emit-llvm -Ilib lib/*.c %s.c; llvm-link -S *.ll -o ../%s_v%d.ll;cd ..",ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}
		else if(bench_type==SEQ_VERSIONS_C4)
		{		
			memset(command,'\0',command_size);
			sprintf(command,"clang -m32 -Wno-return-type -O0 -S -emit-llvm v%d/%s.c -o %s_v%d.ll -Wl,--no-as-needed -ldl",ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}
		else if(bench_type==SEQ_VERSIONS_CF)
		{
			memset(command,'\0',command_size);
			sprintf(command,"cd v%d;clang -g -Wall -S -O0 -emit-llvm -I. mozilla-sha1/*.c cuckoo_filter.c %s.c; llvm-link -S *.ll -o ../%s_v%d.ll;cd ..",ver2,c_source,c_source,ver2);
			mysystem(command,2.0);
		}
		else if(bench_type==SEQ_VERSIONS_MLISP)
		{
			memset(command,'\0',command_size);
			sprintf(command,"clang -O0 -S -emit-llvm v%d/%s.c -o %s_v%d.ll",ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}
		else if(bench_type==SEQ_VERSIONS_GREP)
		{		
			memset(command,'\0',command_size);
			sprintf(command,"clang -lm -O0 -S -emit-llvm -Iv%d v%d/%s.c -o %s_v%d.ll",ver2,ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}
		else if(bench_type==SEQ_VERSIONS_SED)
		{		
			memset(command,'\0',command_size);
			sprintf(command,"clang -O0 -std=c99 -S -emit-llvm v%d/%s.c -o %s_v%d.ll",ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}
		else if(bench_type==SEQ_VERSIONS_FLEX)
		{		
			memset(command,'\0',command_size);
			sprintf(command,"clang -O0 -DHAVE_ALLOCA_H=1 -S -emit-llvm v%d/%s.c -o %s_v%d.ll",ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}
		else if(bench_type==MUT_VERSIONS)
		{		
			memset(command,'\0',command_size);
			sprintf(command,"clang -std=c99 -lm -O0 -S -emit-llvm -Wno-implicit-int -Wno-return-type v%d/%s.c -o %s_v%d.ll",ver2,c_source,c_source,ver2); //generate LLVM IR for the modified source
			mysystem(command,2.0);
		}

		smdiff(c_source,ver1,ver2); //timers 2.51, 2.52, and 2.75 are here [we only need to check times for this function, all others are OK]

		/*memset(command,'\0',command_size);
		sprintf(command,"cat diff.txt | grep -e block -e function >> mydiff.txt;cat mydiff.txt > diff.txt;rm mydiff.txt"); //reduce diff.txt
		system(command);*/

		if(approach==RTS)
		{		
			/*FILE *fp=NULL;

			fp=fopen("blk_limit","r"); //file where the diff info is dumped
			if(fp==NULL)
			{
				printf("error opening file");
			}		

			fscanf(fp,"%llu",&blk_limit);*/
	
			affected_block=(char**)malloc(blk_limit*sizeof(char*));       /*dynamic memory allocation*/
    	
			for(i=0;i<blk_limit;i++)
    		{
    			affected_block[i]=(char*)malloc(aff_blk_dim2*sizeof(char));
				
				if(bench_type==SEQ_VERSIONS_SED || bench_type==SEQ_VERSIONS_FLEX)
				{
					memset(affected_block[i],'\0',aff_blk_dim2);
					strcpy(affected_block[i],"_cs16d004_");				
				}
    		}
		
			//fclose(fp);
		
			/*fp=fopen("diff.txt","r"); //file where the diff info is dumped
			if(fp==NULL)
			{
				printf("error opening file");
			}	
		
			char buff[long_buff_size];
			
			char ffname[short_buff_size];*/
		
			b_affected=0; //count for blocks affected

			if(gettimeofday(&t5,NULL)<0) //timer3 on
					exit(2);

			for(set<string>::iterator i=change_set.begin(),e=change_set.end();i!=e;++i)
			{
				if(bench_type==SEQ_VERSIONS_SED || bench_type==SEQ_VERSIONS_FLEX)
					strcat(affected_block[b_affected],(*i).c_str());
				else
					strcpy(affected_block[b_affected],(*i).c_str());
				
				b_affected++;
			}

			if(gettimeofday(&t6,NULL)<0) //timer3 off
					exit(2);

			time3=((t6.tv_sec*1000000+t6.tv_usec)-(t5.tv_sec*1000000+t5.tv_usec))/1000000.0;
		
			/*while(!feof(fp)) //extract required info from the [diff.txt] dump files
			{
				memset(buff,'\0',long_buff_size);
				fgets(buff,long_buff_size,fp);
	
				if(gettimeofday(&t5,NULL)<0) //timer3 on
					exit(2);
		
				if(mystrstr(buff,"in function")>0)
				{
					if(strlen(buff)>=1)
					{
						buff[strlen(buff)-1]='\0';
				
						unsigned long long int space=0,i=0,idx=0;
		
						while(buff[i]!='\0')
						{
							if(buff[i]==' ')
								space++;
		
							if(space==2)
								break;
		
							i++;
						}
		
						i++;
			
						memset(ffname,'\0',short_buff_size);
		
						while(buff[i]!=':')
						{
							ffname[idx++]=buff[i];				
							i++;
						}
		
						ffname[idx]='\0';
		
						strcat(ffname,",");
					}			
				}		
				else if(mystrstr(buff,"block")>0)
				{
					if(strlen(buff)>=1)
					{
						buff[strlen(buff)-1]='\0';
				
						unsigned long long int i,idx;
						
						i=0;
						idx=strlen(ffname);
		
						while(buff[i]!='%') //block name left-end marker
							i++;
		
						i++;
		
						memset(affected_block[b_affected],'\0',aff_blk_dim2);
		
						strcpy(affected_block[b_affected],ffname);
					
						while(buff[i]!=':') //block name right-end marker
						{
							affected_block[b_affected][idx++]=buff[i];
							i++;
								
							if(buff[i]==' ') //if space occurs
								break;
						}
		
						affected_block[b_affected][idx]='\0';
						b_affected++; //increment block counter
		
					}			
				}
	
				if(gettimeofday(&t6,NULL)<0) //timer3 off
					exit(2);
	
				time3+=((t6.tv_sec*1000000+t6.tv_usec)-(t5.tv_sec*1000000+t5.tv_usec))/1000000.0;
	
			}*/		
	
			//fclose(fp); //close [diff.txt]
		}
		
		//--------------------------------------------------------------End Generate DIFF	--------------------------------------------------------------------
	
		if(approach==RTS)	
		{
			if(prioritized==1) //prioritize by relevance
			{
				if(gettimeofday(&t13_1,NULL)<0) //timer3.51 on
					exit(2);

				prioritize_by_relevance();

				if(gettimeofday(&t14_1,NULL)<0) //timer3.51 off
					exit(2);
				
				if(gettimeofday(&t13_2,NULL)<0) //timer3.52 on
					exit(2);
				
				reorder_tests();	

				if(gettimeofday(&t14_2,NULL)<0) //timer3.52 off
					exit(2);
			}
			else if(prioritized==0) //unprioritized
			{
				if(gettimeofday(&t13_1,NULL)<0) //timer3.51 on
					exit(2);
				
				unprioritized();

				if(gettimeofday(&t14_1,NULL)<0) //timer3.51 off
					exit(2);

				if(gettimeofday(&t13_2,NULL)<0) //timer3.52 on
					exit(2);				

				reorder_tests();

				if(gettimeofday(&t14_2,NULL)<0) //timer3.52 off
					exit(2);			
			}
			else if(prioritized==2) //prioritize randomly
			{
				if(gettimeofday(&t13_1,NULL)<0) //timer3.51 on
					exit(2);

				prioritize_randomly();

				if(gettimeofday(&t14_1,NULL)<0) //timer3.51 off
					exit(2);

				if(gettimeofday(&t13_2,NULL)<0) //timer3.52 on
					exit(2);

				reorder_tests();

				if(gettimeofday(&t14_2,NULL)<0) //timer3.52 off
					exit(2);					
			}
			else if(prioritized==3) //prioritize by confinedness
			{
				if(gettimeofday(&t13_1,NULL)<0) //timer3.51 on
					exit(2);

				prioritize_by_confinedness();

				if(gettimeofday(&t14_1,NULL)<0) //timer3.51 off
					exit(2);

				if(gettimeofday(&t13_2,NULL)<0) //timer3.52 on
					exit(2);
			
				reorder_tests();

				if(gettimeofday(&t14_2,NULL)<0) //timer3.52 off
					exit(2);				
			}
			else if(prioritized==4) //prioritize by relevance and confinedness
			{
				if(gettimeofday(&t13_1,NULL)<0) //timer3.51 on
					exit(2);
			
				prioritize_by_relevance_and_confinedness();
	
				if(gettimeofday(&t14_1,NULL)<0) //timer3.51 off
					exit(2);

				if(gettimeofday(&t13_2,NULL)<0) //timer3.52 on
					exit(2);

				reorder_tests();

				if(gettimeofday(&t14_2,NULL)<0) //timer3.52 off
					exit(2);	
			}
		}
		else if(approach==ALL)
		{
			if(prioritized==2) //prioritize randomly
			{
				if(gettimeofday(&t13_1,NULL)<0) //timer3.51 on
					exit(2);

				prioritize_randomly_all();
		
				if(gettimeofday(&t14_1,NULL)<0) //timer3.51 off
					exit(2);

				if(gettimeofday(&t13_2,NULL)<0) //timer3.52 on
					exit(2);
	
				reorder_tests();

				if(gettimeofday(&t14_2,NULL)<0) //timer3.52 off
					exit(2);	
			}
		}
	
		if(gettimeofday(&t15,NULL)<0) //timer3.75 on
			exit(2);
	
		//reorder_tests();
	
		if(gettimeofday(&t16,NULL)<0) //timer3.75 off
			exit(2);
	
		if(approach==RTS)	
			selection(); //select only required test cases
	
		/*memset(command,'\0',command_size);
		sprintf(command,"wc -l %s",c_source);
		system(command);
	
		memset(command,'\0',command_size);
		sprintf(command,"wc -l %s",c_source_mod1);
		system(command);
	
		memset(command,'\0',command_size);
		sprintf(command,"wc -l *_new.ll");
		system(command);*/

		if(approach==RTS)
			ecc=ECC(); //get ecc value

		for(i=0;i<blk_limit;i++)
   			free(affected_block[i]);
   		
		free(affected_block);
			
		runSelected(c_source,ver2);

		eps=epsilon();
	
		//runAll(file2);
	
		//calculate time
	
		//if(pair==1)
		{
			//time0_25=((t22.tv_sec*1000000+t22.tv_usec)-(t21.tv_sec*1000000+t21.tv_usec))/1000000.0;
	
			time0_5+=((t24.tv_sec*1000000+t24.tv_usec)-(t23.tv_sec*1000000+t23.tv_usec))/1000000.0;
	
			time1=((t2.tv_sec*1000000+t2.tv_usec)-(t1.tv_sec*1000000+t1.tv_usec))/1000000.0;

			//time1_5=((t10.tv_sec*1000000+t10.tv_usec)-(t9.tv_sec*1000000+t9.tv_usec))/1000000.0;
		}
		
		//time2=((t4.tv_sec*1000000+t4.tv_usec)-(t3.tv_sec*1000000+t3.tv_usec))/1000000.0;

		//time2_5=((t18.tv_sec*1000000+t18.tv_usec)-(t17.tv_sec*1000000+t17.tv_usec))/1000000.0;
	
		//time2_75=((t20.tv_sec*1000000+t20.tv_usec)-(t19.tv_sec*1000000+t19.tv_usec))/1000000.0;
	
		//time3=((t6.tv_sec*1000000+t6.tv_usec)-(t5.tv_sec*1000000+t5.tv_usec))/1000000.0;
	
		time3_51=((t14_1.tv_sec*1000000+t14_1.tv_usec)-(t13_1.tv_sec*1000000+t13_1.tv_usec))/1000000.0;

		time3_52=((t14_2.tv_sec*1000000+t14_2.tv_usec)-(t13_2.tv_sec*1000000+t13_2.tv_usec))/1000000.0;
	
		time3_75=((t16.tv_sec*1000000+t16.tv_usec)-(t15.tv_sec*1000000+t15.tv_usec))/1000000.0;
	
		time4=((t8.tv_sec*1000000+t8.tv_usec)-(t7.tv_sec*1000000+t7.tv_usec))/1000000.0;
	
		//time5=((t26.tv_sec*1000000+t26.tv_usec)-(t25.tv_sec*1000000+t25.tv_usec))/1000000.0;
	
		//time6=((t28.tv_sec*1000000+t28.tv_usec)-(t27.tv_sec*1000000+t27.tv_usec))/1000000.0;

		cksum_time=((ce.tv_sec*1000000+ce.tv_usec)-(cs.tv_sec*1000000+cs.tv_usec))/1000000.0;

		time2_51=xmax(time2_511,time2_512);

		time2_5=time2_51+time2_52;

		time3_5=time3_51+time3_52;

		/*if(approach==RTS)		
			xtime=time0_25+time2+time2_5+time2_75+time3+time3_5+time3_75+time4+time5;
		else if(approach==ALL)
			xtime=time0_25+time2+time2_5+time3_5+time3_75+time5;

		if(global_state==GLOBAL_SECTION_SENSITIVE)
			xtime+=cksum_time;
		
		rts_tot+=xtime; //xtime is (online+execution)
	
		all_tot+=time6;*/
	
		/*printf("\nexecution time is %lf s\n\n",xtime);		
	
		//if(pair==1)
		{
			printf("time0.25 is %lf s [source IR generation,removal of comments]{sminstru.c}\n\n",time0_25);
	
			printf("time0.5 is %lf s [source instrumentation]{sminstru.c}\n\n",time0_5);
		
			printf("time1.0 is %lf s [generation of .cov files (with awk '!seen[$0]++')]{engine.c}\n\n",time1);
	
			printf("time1.5 is %lf s [definition of map]{engine.c}\n\n",time1_5);
		}
	
		printf("time2.0 is %lf s [mutant IR generation]{engine.c}\n\n",time2);

		printf("time2.5 is %lf s [a=sed(source IR),b=sed(mutant IR),diff(a,b)]{smdiff.c}\n\n",time2_5);
	
		printf("time2.75 is %lf s [generation of smdiff's output <diff.txt>]{smdiff.c}\n\n",time2_75);
	
		printf("time3.0 is %lf s [extraction of info from <diff.txt>]{engine.c}\n\n",time3);	
		
		printf("time3.5 is %lf s [definition of rank]{engine.c}\n\n",time3_5);
	
		printf("time3.75 is %lf s [reordering of testcases (uses qsort())]{engine.c}\n\n",time3_75);	
	
		printf("time4.0 is %lf s [selection of testcases]{engine.c}\n\n",time4);
	
		printf("time5.0 is %lf s [run selected tests]{engine.c}\n\n",time5);
	
		//printf("---------------------------------------------------------------------------------------------------------------------\n\n");
	
		//printf("time6.0 is %lf s [run all tests]{engine.c}\n\n",time6);*/
	
		xpair++;
	
		//system("rm diff.txt mydiff.txt blk_limit a.out *.ll *.cov exe *.selected *.result commands.sh commands2.sh xtime current_out");
	
		/*#pragma omp parallel for
		for(unsigned long long int i=0;i<test_count;i++) //initialize map
		{
			map[i].is_selected=0; //initialize selection status
			map[i].rank=0.0;
		}*/

		esc_block_per=((long double)(escape.size())/(long double)total_blocks)*100.0;
		aff_block_per=((long double)changed_blocks/(long double)total_blocks)*100.0;
		sel_test_per=((long double)sel_tests/(long double)test_count)*100.0;

		if(approach==RTS)
		{
			//----------------------------------------------------------------------time break-up [begin]------------------------------------------------------------------------

			double online_time1=0.0,offline_time1=0.0,execution_time1=0.0;			

			offline_time1=time0_5+time1+time1_5; //ok 

			//online_time1=time0_25+time2+cksum_time+time2_51+time2_52+time2_75+time3+time3_51+time3_52; //ok

			online_time1=cksum_time+time2_51+time2_52+time2_75+time3+time3_51+time3_52; //ok

			execution_time1=time5; //ok

			xtime=online_time1+execution_time1; //xtime is (online+execution) [OK]

			FILE *ff=NULL;
		
			ff=fopen(argv[7],"wt");
			if(ff==NULL)
			{
				printf("Error opening file\n");
				exit(-1);
			}

			fprintf(ff,"shouvick %lf",xtime);
			fclose(ff);

			ff=fopen("off.time","wt");
			if(ff==NULL)
			{
				printf("Error opening file\n");
				exit(-1);	
			}

			fprintf(ff," %lf\n",offline_time1);

			fclose(ff);

			//------------------------------------------------------------------------begin offline calc-------------------------------------------------------------------------

			//offline.PER_old_IRgen_rem_c=(time0_25/offline_time1)*100.0;
			
			offline.PER_instr_old=(time0_5/offline_time1)*100.0;

			offline.PER_cov_collect=(time1/offline_time1)*100.0;

			offline.PER_fwd_map=(time1_5/offline_time1)*100.0;

			fprintf(stats,"{v%d/%s.c,v%d/%s.c} offline time: %lf s (instr_old=%.2lf%%,cov_collect=%.2lf%%,fwd_map=%.2lf%%)\n",ver1,c_source,ver2,c_source,offline_time1,offline.PER_instr_old,offline.PER_cov_collect,offline.PER_fwd_map);

			//-------------------------------------------------------------------------end offline calc--------------------------------------------------------------------------	

			//-------------------------------------------------------------------------begin online calc-------------------------------------------------------------------------

			//online.PER_old_IRgen_rem_c=(time0_25/online_time1)*100.0;

			//online.PER_new_IRgen=(time2/online_time1)*100.0;

			online.PER_glb_cmp=(cksum_time/online_time1)*100.0;

			online.PER_ol_nw_fld_tmp=(time2_51/online_time1)*100.0;

			online.PER_ux_diff_grep_tail=(time2_52/online_time1)*100.0;
		
			online.PER_prc_mydiff_affSet_crt=(time2_75/online_time1)*100.0;

			online.PER_affArr_crt=(time3/online_time1)*100.0;

			online.PER_prio_tests=(time3_51/online_time1)*100.0;

			online.PER_sort_tests=(time3_52/online_time1)*100.0;

			//fprintf(stats,"{v%d/%s.c,v%d/%s.c} online time: %.2lf s (old_IRgen_rem_c=%.2lf%%,new_IRgen=%.2lf%%,glb_cmp=%.2lf%%,ol_nw_fld_tmp=%.2lf%%,ux_diff_grep_tail=%.2lf%%,prc_mydiff_affSet_crt=%.2lf%%,affArr_crt=%.2lf%%,prio_tests=%.2lf%%,sort_tests=%.2lf%%)\n",ver1,c_source,ver2,c_source,online_time1,online.PER_old_IRgen_rem_c,online.PER_new_IRgen,online.PER_glb_cmp,online.PER_ol_nw_fld_tmp,online.PER_ux_diff_grep_tail,online.PER_prc_mydiff_affSet_crt,online.PER_affArr_crt,online.PER_prio_tests,online.PER_sort_tests);

			fprintf(stats,"{v%d/%s.c,v%d/%s.c} online time: %lf s (glb_cmp=%.2lf%%,ol_nw_fld_tmp=%.2lf%%,ux_diff_grep_tail=%.2lf%%,prc_mydiff_affSet_crt=%.2lf%%,affArr_crt=%.2lf%%,prio_tests=%.2lf%%,sort_tests=%.2lf%%)\n",ver1,c_source,ver2,c_source,online_time1,online.PER_glb_cmp,online.PER_ol_nw_fld_tmp,online.PER_ux_diff_grep_tail,online.PER_prc_mydiff_affSet_crt,online.PER_affArr_crt,online.PER_prio_tests,online.PER_sort_tests);

			//--------------------------------------------------------------------------end online calc--------------------------------------------------------------------------
			
			//------------------------------------------------------------------------begin execution calc-----------------------------------------------------------------------

			execution.PER_gen_exec_verify=(time5/execution_time1)*100.0;

			fprintf(stats,"{v%d/%s.c,v%d/%s.c} test execution time: %lf s (exec_verify=%.2lf%%)\n",ver1,c_source,ver2,c_source,execution_time1,execution.PER_gen_exec_verify);

			//-------------------------------------------------------------------------end execution calc------------------------------------------------------------------------		
			
			//----------------------------------------------------------------------time break-up [end]--------------------------------------------------------------------------

			fprintf(stats,"{v%d/%s.c,v%d/%s.c} basic blocks affected: %.2Lf%%\n",ver1,c_source,ver2,c_source,aff_block_per);
			fprintf(stats,"{v%d/%s.c,v%d/%s.c} basic blocks escaped: %.2Lf%%\n",ver1,c_source,ver2,c_source,esc_block_per);

			//long double value;

			//value=APFD(sel_tests,tf_i);

			//value=APFD(test_count,tf_i);
			
			if(prioritized==1)
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} test selection: %.2Lf%% (%.2f%% threshold) (prioritized)\napproach=Run Selected\nECC=%.6Lf (prioritize by relevance)\nEPS=%.6Lf (prioritize by relevance)\n",ver1,c_source,ver2,c_source,sel_test_per,threshold,ecc,eps);
			else if(prioritized==0)
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} test selection: %.2Lf%% (%.2f%% threshold) (unprioritized)\napproach=Run Selected\nECC=%.6Lf (unprioritized)\nEPS=%.6Lf (unprioritized)\n",ver1,c_source,ver2,c_source,sel_test_per,threshold,ecc,eps);
			else if(prioritized==2)
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} test selection: %.2Lf%% (%.2f%% threshold) (prioritized)\napproach=Run Selected\nECC=%.6Lf (prioritize randomly)\nEPS=%.6Lf (prioritize randomly)\n",ver1,c_source,ver2,c_source,sel_test_per,threshold,ecc,eps);
			else if(prioritized==3)
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} test selection: %.2Lf%% (%.2f%% threshold) (prioritized)\napproach=Run Selected\nECC=%.6Lf (prioritize by confinedness)\nEPS=%.6Lf (prioritize by confinedness)\n",ver1,c_source,ver2,c_source,sel_test_per,threshold,ecc,eps);
			else if(prioritized==4)
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} test selection: %.2Lf%% (%.2f%% threshold) (prioritized)\napproach=Run Selected\nECC=%.6Lf (prioritize by relevance and confinedness)\nEPS=%.6Lf (prioritize by relevance and confinedness)\n",ver1,c_source,ver2,c_source,sel_test_per,threshold,ecc,eps);

			fprintf(stats,"tests failed=%llu\n",tests_failed);
			fprintf(stats,"escaped basic blocks: ");

			for(set<string>::iterator i=escape.begin(),e=escape.end();i!=e;++i)
				fprintf(stats,"(%s) ",(*i).c_str());
			
			if(escape.size()==0)
				fprintf(stats,"NIL");

			fprintf(stats,"\n\n");			
		}
		else if(approach==ALL)
		{
			//----------------------------------------------------------------------time break-up [begin]------------------------------------------------------------------------

			double online_time1=0.0,offline_time1=0.0,execution_time1=0.0;			

			offline_time1=time0_5+time1+time1_5; //ok 

			//online_time1=time0_25+time2+cksum_time+time2_51+time2_52+time2_75+time3+time3_51+time3_52; //ok

			online_time1=cksum_time+time2_51+time2_52+time2_75+time3+time3_51+time3_52; //ok

			execution_time1=time5; //ok
		
			xtime=online_time1+execution_time1; //xtime is (online+execution) [OK]

			FILE *ff=NULL;
		
			ff=fopen(argv[7],"wt");
			if(ff==NULL)
			{
				printf("Error opening file\n");
				exit(-1);
			}

			fprintf(ff,"shouvick %lf",xtime);
			fclose(ff);

			ff=fopen("off.time","wt");
			if(ff==NULL)
			{
				printf("Error opening file\n");
				exit(-1);	
			}

			fprintf(ff," %lf\n",offline_time1);

			fclose(ff);

			//------------------------------------------------------------------------begin offline calc-------------------------------------------------------------------------

			//offline.PER_old_IRgen_rem_c=(time0_25/offline_time1)*100.0;
			
			offline.PER_instr_old=(time0_5/offline_time1)*100.0;

			offline.PER_cov_collect=(time1/offline_time1)*100.0;

			offline.PER_fwd_map=(time1_5/offline_time1)*100.0;

			fprintf(stats,"{v%d/%s.c,v%d/%s.c} offline time: %lf s (instr_old=%.2lf%%,cov_collect=%.2lf%%,fwd_map=%.2lf%%)\n",ver1,c_source,ver2,c_source,offline_time1,offline.PER_instr_old,offline.PER_cov_collect,offline.PER_fwd_map);

			//-------------------------------------------------------------------------end offline calc--------------------------------------------------------------------------	

			//-------------------------------------------------------------------------begin online calc-------------------------------------------------------------------------

			//online.PER_old_IRgen_rem_c=(time0_25/online_time1)*100.0;

			//online.PER_new_IRgen=(time2/online_time1)*100.0;

			online.PER_glb_cmp=(cksum_time/online_time1)*100.0;

			online.PER_ol_nw_fld_tmp=(time2_51/online_time1)*100.0;

			online.PER_ux_diff_grep_tail=(time2_52/online_time1)*100.0;
		
			online.PER_prc_mydiff_affSet_crt=(time2_75/online_time1)*100.0;

			online.PER_affArr_crt=(time3/online_time1)*100.0;

			online.PER_prio_tests=(time3_51/online_time1)*100.0;

			online.PER_sort_tests=(time3_52/online_time1)*100.0;

			//fprintf(stats,"{v%d/%s.c,v%d/%s.c} online time: %.2lf s (old_IRgen_rem_c=%.2lf%%,new_IRgen=%.2lf%%,glb_cmp=%.2lf%%,ol_nw_fld_tmp=%.2lf%%,ux_diff_grep_tail=%.2lf%%,prc_mydiff_affSet_crt=%.2lf%%,affArr_crt=%.2lf%%,prio_tests=%.2lf%%,sort_tests=%.2lf%%)\n",ver1,c_source,ver2,c_source,online_time1,online.PER_old_IRgen_rem_c,online.PER_new_IRgen,online.PER_glb_cmp,online.PER_ol_nw_fld_tmp,online.PER_ux_diff_grep_tail,online.PER_prc_mydiff_affSet_crt,online.PER_affArr_crt,online.PER_prio_tests,online.PER_sort_tests);

			fprintf(stats,"{v%d/%s.c,v%d/%s.c} online time: %lf s (glb_cmp=%.2lf%%,ol_nw_fld_tmp=%.2lf%%,ux_diff_grep_tail=%.2lf%%,prc_mydiff_affSet_crt=%.2lf%%,affArr_crt=%.2lf%%,prio_tests=%.2lf%%,sort_tests=%.2lf%%)\n",ver1,c_source,ver2,c_source,online_time1,online.PER_glb_cmp,online.PER_ol_nw_fld_tmp,online.PER_ux_diff_grep_tail,online.PER_prc_mydiff_affSet_crt,online.PER_affArr_crt,online.PER_prio_tests,online.PER_sort_tests);

			//--------------------------------------------------------------------------end online calc--------------------------------------------------------------------------
			
			//------------------------------------------------------------------------begin execution calc-----------------------------------------------------------------------

			execution.PER_gen_exec_verify=(time5/execution_time1)*100.0;

			fprintf(stats,"{v%d/%s.c,v%d/%s.c} test execution time: %lf s (exec_verify=%.2lf%%)\n",ver1,c_source,ver2,c_source,execution_time1,execution.PER_gen_exec_verify);

			//-------------------------------------------------------------------------end execution calc------------------------------------------------------------------------		
			
			//----------------------------------------------------------------------time break-up [end]--------------------------------------------------------------------------
			
			//long double value;

			//value=APFD(sel_tests,tf_i);

			//value=APFD(test_count,tf_i);

			if(prioritized==2)
			{
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} global section affected\n",ver1,c_source,ver2,c_source);
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} test selection: 100.00%%\napproach=Retest All\nEPS=%.6Lf (prioritize randomly)\n",ver1,c_source,ver2,c_source,eps);
				fprintf(stats,"tests failed=%llu\n\n",tests_failed);
			}
			else
			{			
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} global section affected\n",ver1,c_source,ver2,c_source);
				fprintf(stats,"{v%d/%s.c,v%d/%s.c} test selection: 100.00%%\napproach=Retest All\nEPS=%.6Lf (unprioritized)\n",ver1,c_source,ver2,c_source,eps);
				fprintf(stats,"tests failed=%llu\n\n",tests_failed);
			}
		}
	}

	fclose(ver);
	fclose(stats);

	free_map();
	
	//printf("*********************************************************************************************************************\n\n");
	
	//printf("Overall RTS time is %lf s\n\n",rts_tot); //prints overall RTS end-to-end time

	//printf("Overall ALL time is %lf s\n\n",all_tot); //prints overall ALL time

	//printf("Percentage (%lf%%)\n\n",((rts_tot/all_tot)*100.0)); //prints normalized RTS time [normalized w.r.t. ALL time]

	return 0;
}
