/*
Simple non code license (SNCL) Version 1.10.0

Copyright (C) 2019 Shouvick Mondal, and Rupesh Nasre.

The original creator(s) of the data or text under this license is thereby
called the licensor.

The person physical or juridical obtaining a copy of the data or text
under this license is thereby called the licensee.

The data or text under this license is therefore called the object.

1. The licensee rights and obligations
1.1. The licensee have the right to obtain a free copy of the object.
1.2. It is a right of the licensee to redistribute unaltered copies of
     the object although commercial use is utterly forbidden
     (except with licensor express written consent).
1.3. The licensee is given the right to adapt or modify the object to
     suit his needs and to redistribute the modified version subject to
     the following conditions:
1.3.1. You must keep the following notice in any copy of the object that
       you may create: Written originally by Shouvick Mondal, and Rupesh Nasre
       on 2019-04-16.
1.3.2. You must keep a changelog somewhere inside the modified object in
       the following format: {version} {YYYY-MM-DD HH:MM (24 hours cycle)}
       {Description} {pages changed list}.
1.3.3. The same rules about commercial use stated in clause 1.1 applies
       here.
1.3.4. You must include the following notice in any object-modified copies
       you redistribute: This document or data is a derivative of Mahtab
       and the information contained here may or may not represent the
       original document or data.
1.3.5. In case of juridical problems that may arise from licensee edits the
       licensee is liable instead of the licensor.
1.4. The licensee is given the right to redistribute work including any
     licensor copyrights originally contained in the object but not to use
     it on its own behalf. (void if the clause 3 is present)
1.5. All of the above clauses are void if the licensee fails to accomplish
     his obligations established in clause 1.
1.6. If the 1.5 clause becomes true the licensee must pay for any costs the
     licensor may have with juridical actions against him.
2. The liability of the licensor
2.1. The licensor is liable only for what himself wrote regarding juridical
     issues related to injury, racism or offense and any other crimes.
2.2. The licensor is not liable for the content that was edited by third
     parties and the liability for such cases falls over the licensee as
     described in 1.3.5.
*/

long double epsilon()
{
	long double eps=0.0,d_vec_mag=0.0,max_mag=0.0,d_cap=0.0;		
	
	unsigned long long int *nu_star,*nu_rats,*nu,*d_vec,n=windows_failed,i;
	
	nu_star=(unsigned long long int *)malloc(n*sizeof(unsigned long long int)); //memory allocated for nu_star[...] (optimal)
	nu_rats=(unsigned long long int *)malloc(n*sizeof(unsigned long long int)); //memory allocated for nu_rats[...] (worst)
	nu=(unsigned long long int *)malloc(n*sizeof(unsigned long long int)); //memory allocated for nu[...] (current)

	d_vec=(unsigned long long int *)malloc(n*sizeof(unsigned long long int)); //memory allocated for d vector

	for(i=0;i<n;i++)
	{
		nu_star[i]=i+1; //best-case defined
		nu_rats[i]=test_count+nu_star[i]; //worst-case defined
	}

	if(pos_failed.size()==n)
	{
		unsigned long long int count=0;

		for(set<unsigned long long int>::iterator j=pos_failed.begin(),e=pos_failed.end();j!=e;++j)
		{
			nu[count]=*j; //nu[...] defined
			//printf("nu[%llu]=%llu\n",count,nu[count]);
			count++;
		}

		for(i=0;i<n;i++)
		{
			d_vec[i]=nu[i]-nu_star[i];
			d_vec_mag+=(long double)d_vec[i];
			max_mag+=(long double)test_count;
		}

		d_cap=d_vec_mag/max_mag; //distance d_cap defined
		
		eps=1.0-d_cap; //epsilon defined		
	}
	else
		eps=-1.0;

	if(tests_failed==0)
		eps=0.0;

	free(nu_star);
	free(nu_rats);
	free(nu);
	free(d_vec);

	return(eps);
}
