/*
Simple non code license (SNCL) Version 1.10.0

Copyright (C) 2019 Shouvick Mondal, and Rupesh Nasre.

The original creator(s) of the data or text under this license is thereby
called the licensor.

The person physical or juridical obtaining a copy of the data or text
under this license is thereby called the licensee.

The data or text under this license is therefore called the object.

1. The licensee rights and obligations
1.1. The licensee have the right to obtain a free copy of the object.
1.2. It is a right of the licensee to redistribute unaltered copies of
     the object although commercial use is utterly forbidden
     (except with licensor express written consent).
1.3. The licensee is given the right to adapt or modify the object to
     suit his needs and to redistribute the modified version subject to
     the following conditions:
1.3.1. You must keep the following notice in any copy of the object that
       you may create: Written originally by Shouvick Mondal, and Rupesh Nasre
       on 2019-04-16.
1.3.2. You must keep a changelog somewhere inside the modified object in
       the following format: {version} {YYYY-MM-DD HH:MM (24 hours cycle)}
       {Description} {pages changed list}.
1.3.3. The same rules about commercial use stated in clause 1.1 applies
       here.
1.3.4. You must include the following notice in any object-modified copies
       you redistribute: This document or data is a derivative of Mahtab
       and the information contained here may or may not represent the
       original document or data.
1.3.5. In case of juridical problems that may arise from licensee edits the
       licensee is liable instead of the licensor.
1.4. The licensee is given the right to redistribute work including any
     licensor copyrights originally contained in the object but not to use
     it on its own behalf. (void if the clause 3 is present)
1.5. All of the above clauses are void if the licensee fails to accomplish
     his obligations established in clause 1.
1.6. If the 1.5 clause becomes true the licensee must pay for any costs the
     licensor may have with juridical actions against him.
2. The liability of the licensor
2.1. The licensor is liable only for what himself wrote regarding juridical
     issues related to injury, racism or offense and any other crimes.
2.2. The licensor is not liable for the content that was edited by third
     parties and the liability for such cases falls over the licensee as
     described in 1.3.5.
*/

void add_affected(const char *funname,const char* bname)
{
	string str1(funname),str2(bname);

	string str3=str1+","+str2;

	change_set.insert(str3);	
}
void dump_diff()
{
	FILE *fp2=fopen("diff.txt","wt");
	if(fp2==NULL)
	{
		printf("error\n");
		exit(1);
	}

	for(set<string>::iterator i=change_set.begin(),e=change_set.end();i!=e;++i)
		fprintf(fp2,"(%s)\n",(*i).c_str());

	fclose(fp2);
}
void smdiff(char *fn,int v1,int v2)
{
	FILE *fp/*,*fp2*/;

	int mode=0,ck_stat=0;

	char buff[long_buff_size];
	char funname[short_buff_size];
	char blockname[short_buff_size];
	char command[command_size];
	char f1name[c_source_fname_size];
	char f2name[c_source_mod1_fname_size];
	char fname[2][c_source_mod1_fname_size];

	memset(f1name,'\0',c_source_fname_size);
	memset(f2name,'\0',c_source_mod1_fname_size);	
	memset(fname[0],'\0',c_source_mod1_fname_size);	
	memset(fname[1],'\0',c_source_mod1_fname_size);	

	sprintf(f1name,"%s_v%d.ll",fn,v1);
	sprintf(fname[0],"%s_v%d.ll",fn,v1);
	sprintf(f2name,"%s_v%d.ll",fn,v2);
	sprintf(fname[1],"%s_v%d.ll",fn,v2);

	blk_limit=0;

	//globals1.clear();

	globals[0].clear();

	//globals2.clear();

	globals[1].clear();

	change_set.clear();

	if(global_state==GLOBAL_SECTION_SENSITIVE)
	{
		if(gettimeofday(&cs,NULL)<0) //timer_cksum on
			exit(2);

		#pragma omp parallel for
		for(int i=0;i<=1;i++)
		{
			FILE *fp=fopen(fname[i],"r");
			if(fp==NULL)
			{
				printf("Error opening file\n");
				exit(-1);
			}

			int semi=0;
			int count=0;

			char buff[long_buff_size];
	
			while(!feof(fp))
			{
				memset(buff,'\0',long_buff_size);
				fgets(buff,long_buff_size,fp);
				count++;
	
				if(buff[0]==';')
				{
					semi++;
	
					if(semi==2)
						break;			
				}
	
				if(count>4 && buff[0]!=' ' && buff[0]!='\n')
				{
					const char *s=buff;
					string str(s);
					globals[i].insert(str);
				}
			}

			fclose(fp);
		}

		/*fp2=fopen(f2name,"r");
		if(fp2==NULL)
		{
			printf("Error opening file");
			exit(-1);
		}

		semi=0;
		count=0;
	
		while(!feof(fp2))
		{
			memset(buff,'\0',long_buff_size);
			fgets(buff,long_buff_size,fp2);
			count++;

			if(buff[0]==';')
			{
				semi++;

				if(semi==2)
					break;			
			}

			if(count>4 && buff[0]!=' ' && buff[0]!='\n')
			{
				const char *s=buff;
				string str(s);
				globals2.insert(str);
			}
		}

		fclose(fp2);*/

		/*for(set<string>::iterator i=globals1.begin(),e=globals1.end();i!=e;++i)
			cout<< "globals1 (" << *i <<")\n";

		for(set<string>::iterator i=globals2.begin(),e=globals2.end();i!=e;++i)
			cout<< "globals2 (" << *i <<")\n";*/

		if(globals[0]==globals[1])
			ck_stat=1;
		else
			ck_stat=0;
	
		if(gettimeofday(&ce,NULL)<0) //timer_cksum off
			exit(2);

		if(ck_stat==1)
		{
			/*memset(command,'\0',command_size);
			sprintf(command,"sed 's/label %%/label ?/g' %s > temp.txt; cat temp.txt > %s; rm temp.txt",f1name,f1name);
			mysystem(command,2.5);*/

			//memset(command,'\0',command_size);
			//sprintf(command,"sed 's/%%[0-9][0-9]*/$/g' %s > temp.txt; cat temp.txt > %s; rm temp.txt",f1name,f1name);
			//mysystem(command,2.51);

			/*memset(command,'\0',command_size);
			sprintf(command,"sed 's/label %%/label ?/g' %s > temp.txt; cat temp.txt > %s; rm temp.txt",f2name,f2name);
			mysystem(command,2.5);*/
	
			//memset(command,'\0',command_size);
			//sprintf(command,"sed 's/%%[0-9][0-9]*/$/g' %s > temp.txt; cat temp.txt > %s; rm temp.txt",f2name,f2name);
			//mysystem(command,2.51);

			double ch[2];

			ch[0]=2.511;
			ch[1]=2.512;
			
			char xfname[2][c_source_fname_size];
			char xbuff[2][command_size];

			strcpy(xfname[0],f1name);
			strcpy(xfname[1],f2name);

			strcpy(xbuff[0],"sed 's/%%[0-9][0-9]*/$/g' %s > temp1.txt; cat temp1.txt > %s; rm temp1.txt");	
			strcpy(xbuff[1],"sed 's/%%[0-9][0-9]*/$/g' %s > temp2.txt; cat temp2.txt > %s; rm temp2.txt");				

			#pragma omp parallel for
			for(int i=0;i<=1;i++)
			{
				char xcommand[command_size];

				memset(xcommand,'\0',command_size);
				sprintf(xcommand,xbuff[i],xfname[i],xfname[i]);
				mysystem(xcommand,ch[i]);		
			}

			memset(command,'\0',command_size);
			sprintf(command,"diff -y %s %s | grep -e \"define\" -e \":\" -e \"|\" -e \"<\" -e \">\" | tail -n +5 > mydiff.txt",f1name,f2name);
			mysystem(command,2.52);
	
			fp=fopen("mydiff.txt","r");
			if(fp==NULL)
			{
				printf("error\n");
				exit(1);
			}
	
			/*fp2=fopen("diff.txt","wt");
			if(fp2==NULL)
			{
				printf("error");
				exit(1);
			}*/

			if(gettimeofday(&t19,NULL)<0) //timer 2.75 on
				exit(2);
		
			while(!feof(fp))
			{
				memset(buff,'\0',long_buff_size);
				fgets(buff,long_buff_size,fp);

				/*if(gettimeofday(&t19,NULL)<0) //timer 2.75 on
					exit(2);*/
		
				if(mystrstr(buff,"define")>0)
				{
					int i=0,c=0;
		
					while(buff[i]!='\0')
					{
						if(buff[i]=='@')
						{
							i++;
							break;
						}
		
						i++;
					}
		
					memset(funname,'\0',short_buff_size);
		
					while(buff[i]!='\0')
					{
						if(buff[i]=='(')
						{
							c++;
							funname[c]='\0';
						}
						
						funname[c]=buff[i];
						c++;
						i++;	
					}
		
					//fprintf(fp2,"in function %s:\n",funname);
		
					mode=1;
		
				}
				else if(mode>=1 && mystrstr(buff,":")>0 && mystrstr(buff,"<")==0 && mystrstr(buff,">")==0)
				{
					int i=0,c=0;
		
					memset(blockname,'\0',short_buff_size);
		
					while(buff[i]!='\0')
					{
						if(buff[i]==':')
						{
							c++;
							blockname[c]='\0';
						}
						
						blockname[c]=buff[i];
						c++;
						i++;	
					}
		
					//printf("Current block: (%s,%s)\n",funname,blockname);
		
					mode=2;
				}
				else if(mode>=1 && mystrstr(buff,":")>0 && (mystrstr(buff,"<")>0 || mystrstr(buff,">")>0))
				{
					if(mystrstr(buff,"<")>0)
					{
						int i=0,c=0;
	
						memset(blockname,'\0',short_buff_size);
		
						while(buff[i]!='\0')
						{
							if(buff[i]==':')
							{
								c++;
								blockname[c]='\0';
							}
							
							blockname[c]=buff[i];
							c++;
							i++;	
						}	
	
						//printf("Current block: (%s,%s)\n",funname,blockname);
	
						mode=2;
					}
					else if(mystrstr(buff,">")>0)
					{
						int i=0,c=0;

						while(buff[i]!='\0')
						{
							if(buff[i]=='>')
							{
								i++;
								break;
							}
		
							i++;
						}

						while(buff[i]!='\0')
						{
							if(buff[i]!='\t')
								break;
		
							i++;
						}
	
						memset(blockname,'\0',short_buff_size);
	
						while(buff[i]!='\0')
						{
							if(buff[i]==':')
							{
								c++;
								blockname[c]='\0';
							}
						
							blockname[c]=buff[i];
							c++;
							i++;	
						}	
	
						//printf("Current block: (%s,%s)\n",funname,blockname);
	
						mode=2;
					}

				}
				else if(mode>=2)
				{
					if(mystrstr(blockname," ")==0)
					{			
						if(mystrstr(buff,"|")>0)
						{
							//blk_limit++;
							//fprintf(fp2,"  in block %%%s:\n",blockname);
							mode=1;
							//changed_blocks++;
							add_affected(funname,blockname);
						}
						else if(mystrstr(buff,">")>0)
						{
							//blk_limit++;
							//fprintf(fp2,"  in block %%%s:\n",blockname);
							mode=1;
							//changed_blocks++;
							add_affected(funname,blockname);
						}
						else if(mystrstr(buff,"<")>0)
						{
							//blk_limit++;
							//fprintf(fp2,"  in block %%%s:\n",blockname);
							mode=1;
							//changed_blocks++;
							add_affected(funname,blockname);
						}
					}			
				}

				/*if(gettimeofday(&t20,NULL)<0) //timer 2.75 off
					exit(2);

				time2_75+=((t20.tv_sec*1000000+t20.tv_usec)-(t19.tv_sec*1000000+t19.tv_usec))/1000000.0;*/
			}

			if(gettimeofday(&t20,NULL)<0) //timer 2.75 off
				exit(2);

			time2_75=((t20.tv_sec*1000000+t20.tv_usec)-(t19.tv_sec*1000000+t19.tv_usec))/1000000.0;

			approach=RTS;

			fclose(fp);
			//fclose(fp2);

			blk_limit=change_set.size();
			changed_blocks=blk_limit;

			/*sprintf(buff,"echo %llu > blk_limit",blk_limit);
			system(buff);*/

			dump_diff();
		}
		else
		{
			approach=ALL;
		}
	}
	else
	{
		/*memset(command,'\0',command_size);
		sprintf(command,"sed 's/label %%/label ?/g' %s > temp.txt; cat temp.txt > %s; rm temp.txt",f1name,f1name);
		mysystem(command,2.5);*/

		//memset(command,'\0',command_size);
		//sprintf(command,"sed 's/%%[0-9][0-9]*/$/g' %s > temp.txt; cat temp.txt > %s; rm temp.txt",f1name,f1name);
		//mysystem(command,2.51);

		/*memset(command,'\0',command_size);
		sprintf(command,"sed 's/label %%/label ?/g' %s > temp.txt; cat temp.txt > %s; rm temp.txt",f2name,f2name);
		mysystem(command,2.5);*/

		//memset(command,'\0',command_size);
		//sprintf(command,"sed 's/%%[0-9][0-9]*/$/g' %s > temp.txt; cat temp.txt > %s; rm temp.txt",f2name,f2name);
		//mysystem(command,2.51);

		double ch[2];

		ch[0]=2.511;
		ch[1]=2.512;
			
		char xfname[2][c_source_fname_size];
		char xbuff[2][command_size];

		strcpy(xfname[0],f1name);
		strcpy(xfname[1],f2name);

		strcpy(xbuff[0],"sed 's/%%[0-9][0-9]*/$/g' %s > temp1.txt; cat temp1.txt > %s; rm temp1.txt");	
		strcpy(xbuff[1],"sed 's/%%[0-9][0-9]*/$/g' %s > temp2.txt; cat temp2.txt > %s; rm temp2.txt");				

		#pragma omp parallel for
		for(int i=0;i<=1;i++)
		{
			char xcommand[command_size];

			memset(xcommand,'\0',command_size);
			sprintf(xcommand,xbuff[i],xfname[i],xfname[i]);
			mysystem(xcommand,ch[i]);		
		}
	
		memset(command,'\0',command_size);
		sprintf(command,"diff -y %s %s | grep -e \"define\" -e \":\" -e \"|\" -e \"<\" -e \">\" | tail -n +5 > mydiff.txt",f1name,f2name);
		mysystem(command,2.52);	
	
		fp=fopen("mydiff.txt","r");
		if(fp==NULL)
		{
			printf("error\n");
			exit(1);
		}

		/*fp2=fopen("diff.txt","wt");
		if(fp2==NULL)
		{
			printf("error");
			exit(1);
		}*/

		if(gettimeofday(&t19,NULL)<0) //timer 2.75 on
			exit(2);
	
		while(!feof(fp))
		{
			memset(buff,'\0',long_buff_size);
			fgets(buff,long_buff_size,fp);

			/*if(gettimeofday(&t19,NULL)<0) //timer 2.75 on
				exit(2);*/
	
			if(mystrstr(buff,"define")>0)
			{
				int i=0,c=0;
	
				while(buff[i]!='\0')
				{
					if(buff[i]=='@')
					{
						i++;
						break;
					}
	
					i++;
				}
	
				memset(funname,'\0',short_buff_size);
	
				while(buff[i]!='\0')
				{
					if(buff[i]=='(')
					{
						c++;
						funname[c]='\0';
					}
					
					funname[c]=buff[i];
					c++;
					i++;	
				}
	
				//fprintf(fp2,"in function %s:\n",funname);
	
				mode=1;
	
			}
			else if(mode>=1 && mystrstr(buff,":")>0 && mystrstr(buff,"<")==0 && mystrstr(buff,">")==0)
			{
				int i=0,c=0;
	
				memset(blockname,'\0',short_buff_size);
	
				while(buff[i]!='\0')
				{
					if(buff[i]==':')
					{
						c++;
						blockname[c]='\0';
					}
					
					blockname[c]=buff[i];
					c++;
					i++;	
				}
	
				//printf("Current block: (%s,%s)\n",funname,blockname);
	
				mode=2;
			}
			else if(mode>=1 && mystrstr(buff,":")>0 && (mystrstr(buff,"<")>0 || mystrstr(buff,">")>0))
			{
				if(mystrstr(buff,"<")>0)
				{
					int i=0,c=0;
	
					memset(blockname,'\0',short_buff_size);
	
					while(buff[i]!='\0')
					{
						if(buff[i]==':')
						{
							c++;
							blockname[c]='\0';
						}
						
						blockname[c]=buff[i];
						c++;
						i++;	
					}	
	
					//printf("Current block: (%s,%s)\n",funname,blockname);
	
					mode=2;
				}
				else if(mystrstr(buff,">")>0)
				{
					int i=0,c=0;

					while(buff[i]!='\0')
					{
						if(buff[i]=='>')
						{
							i++;
							break;
						}
	
						i++;
					}

					while(buff[i]!='\0')
					{
						if(buff[i]!='\t')
							break;

						i++;
					}
	
					memset(blockname,'\0',short_buff_size);
	
					while(buff[i]!='\0')
					{
						if(buff[i]==':')
						{
							c++;
							blockname[c]='\0';
						}
						
						blockname[c]=buff[i];
						c++;
						i++;	
					}	
	
					//printf("Current block: (%s,%s)\n",funname,blockname);
	
					mode=2;
				}
				
			}
			else if(mode>=2)
			{
				if(mystrstr(blockname," ")==0)
				{			
					if(mystrstr(buff,"|")>0)
					{
						//blk_limit++;
						//fprintf(fp2,"  in block %%%s:\n",blockname);
						mode=1;
						//changed_blocks++;
						add_affected(funname,blockname);
					}
					else if(mystrstr(buff,">")>0)
					{
						//blk_limit++;
						//fprintf(fp2,"  in block %%%s:\n",blockname);
						mode=1;
						//changed_blocks++;
						add_affected(funname,blockname);
					}
					else if(mystrstr(buff,"<")>0)
					{
						//blk_limit++;
						//fprintf(fp2,"  in block %%%s:\n",blockname);
						mode=1;
						//changed_blocks++;
						add_affected(funname,blockname);
					}
				}			
			}

			/*if(gettimeofday(&t20,NULL)<0) //timer 2.75 off
				exit(2);

			time2_75+=((t20.tv_sec*1000000+t20.tv_usec)-(t19.tv_sec*1000000+t19.tv_usec))/1000000.0;*/
		}

		if(gettimeofday(&t20,NULL)<0) //timer 2.75 off
			exit(2);

		time2_75=((t20.tv_sec*1000000+t20.tv_usec)-(t19.tv_sec*1000000+t19.tv_usec))/1000000.0;
		
		approach=RTS;
		fclose(fp);
		//fclose(fp2);

		blk_limit=change_set.size();
		changed_blocks=blk_limit;

		/*sprintf(buff,"echo %llu > blk_limit",blk_limit);
		system(buff);*/

		dump_diff();
	}
}
