/*
Simple non code license (SNCL) Version 1.10.0

Copyright (C) 2019 Shouvick Mondal, and Rupesh Nasre.

The original creator(s) of the data or text under this license is thereby
called the licensor.

The person physical or juridical obtaining a copy of the data or text
under this license is thereby called the licensee.

The data or text under this license is therefore called the object.

1. The licensee rights and obligations
1.1. The licensee have the right to obtain a free copy of the object.
1.2. It is a right of the licensee to redistribute unaltered copies of
     the object although commercial use is utterly forbidden
     (except with licensor express written consent).
1.3. The licensee is given the right to adapt or modify the object to
     suit his needs and to redistribute the modified version subject to
     the following conditions:
1.3.1. You must keep the following notice in any copy of the object that
       you may create: Written originally by Shouvick Mondal, and Rupesh Nasre
       on 2019-04-16.
1.3.2. You must keep a changelog somewhere inside the modified object in
       the following format: {version} {YYYY-MM-DD HH:MM (24 hours cycle)}
       {Description} {pages changed list}.
1.3.3. The same rules about commercial use stated in clause 1.1 applies
       here.
1.3.4. You must include the following notice in any object-modified copies
       you redistribute: This document or data is a derivative of Mahtab
       and the information contained here may or may not represent the
       original document or data.
1.3.5. In case of juridical problems that may arise from licensee edits the
       licensee is liable instead of the licensor.
1.4. The licensee is given the right to redistribute work including any
     licensor copyrights originally contained in the object but not to use
     it on its own behalf. (void if the clause 3 is present)
1.5. All of the above clauses are void if the licensee fails to accomplish
     his obligations established in clause 1.
1.6. If the 1.5 clause becomes true the licensee must pay for any costs the
     licensor may have with juridical actions against him.
2. The liability of the licensor
2.1. The licensor is liable only for what himself wrote regarding juridical
     issues related to injury, racism or offense and any other crimes.
2.2. The licensor is not liable for the content that was edited by third
     parties and the liability for such cases falls over the licensee as
     described in 1.3.5.
*/

void sminstru(char *source_file)
{
	char buff[instru_buff_size];
	char source_fname[short_buff_size];
	char dest_fname[short_buff_size];
	char funname[short_buff_size];
	char blockname[short_buff_size];
	char save[2*short_buff_size];
	char command[command_size];
	char ss[short_buff_size];

	FILE *source=NULL,*dest=NULL,*aux=NULL;
		
	memset(source_fname,'\0',short_buff_size);
	memset(dest_fname,'\0',short_buff_size);
	
	//printf("Source file: [%s]\n",source_fname);

	int mode=0,blankline=0,semi=0,pstat=0,att1=0,dstat=0,estat=0,len_ss=0;

	//printf("Destination file: [%s]\n",dest_fname);

	if(bench_type==SEQ_VERSIONS)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -DSTDC_HEADERS=1 -DHAVE_UNISTD_H=1 -DDIRENT=1 -DHAVE_ALLOCA_H=1 -DHAVE_CONFIG_H -I. -lm -O0 -S -emit-llvm -Wno-implicit-int -Wno-return-type v%d/%s.c -o %s_v%d.ll;sed 's/; preds = [%% . a-z A-Z 0-9 , _ !]*/ /g' %s_v%d.ll > temp.txt; cat temp.txt > %s_v%d.ll; rm temp.txt",ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==SEQ_VERSIONS_GIT)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -std=gnu99 -fgnu89-inline -fPIC -Iv%d/src v%d/src/*.c -S -O0 -emit-llvm v%d/%s.c -lm; llvm-link -S *.ll -o %s_v%d.ll; sed 's/; preds = [%% . a-z A-Z 0-9 , ! _]*/ /g' %s_v%d.ll > temp.txt; cat temp.txt > %s_v%d.ll; rm temp.txt",ver1,ver1,ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==SEQ_VERSIONS_SCD)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -S -O0 -emit-llvm -Iv%d/lib v%d/lib/*.c v%d/%s.c; llvm-link -S *.ll -o %s_v%d.ll; sed 's/; preds = [%% . a-z A-Z 0-9 , ! _]*/ /g' %s_v%d.ll > temp.txt; cat temp.txt > %s_v%d.ll; rm temp.txt",ver1,ver1,ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==SEQ_VERSIONS_C4)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -m32 -Wno-return-type -S -O0 -emit-llvm v%d/%s.c -o %s_v%d.ll -Wl,--no-as-needed -ldl; sed 's/; preds = [%% . a-z A-Z 0-9 , ! _]*/ /g' %s_v%d.ll > temp.txt; cat temp.txt > %s_v%d.ll; rm temp.txt",ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==SEQ_VERSIONS_CF)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -g -Wall -S -O0 -emit-llvm -Iv%d v%d/mozilla-sha1/*.c v%d/cuckoo_filter.c v%d/%s.c; llvm-link -S *.ll -o %s_v%d.ll; sed 's/; preds = [%% . a-z A-Z 0-9 , ! _]*/ /g' %s_v%d.ll > temp.txt; cat temp.txt > %s_v%d.ll; rm temp.txt",ver1,ver1,ver1,ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==SEQ_VERSIONS_MLISP)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -O0 -S -emit-llvm v%d/%s.c -o %s_v%d.ll;sed 's/; preds = [%% . a-z A-Z 0-9 , _ !]*/ /g' %s_v%d.ll > temp.txt; cat temp.txt > %s_v%d.ll; rm temp.txt",ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==SEQ_VERSIONS_GREP)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -Iv%d -O0 -S -emit-llvm v%d/%s.c -o %s_v%d.ll;sed 's/; preds = [%% . a-z A-Z 0-9 , _ !]*/ /g' %s_v%d.ll > temp.txt;sed 's/No predecessors!/ /g' temp.txt > %s_v%d.ll; rm temp.txt",ver1,ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==SEQ_VERSIONS_SED)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -std=c99 -O0 -S -emit-llvm v%d/%s.c -o %s_v%d.ll;sed 's/; preds = [%% . a-z A-Z 0-9 , _ !]*/ /g' %s_v%d.ll > temp.txt;sed 's/No predecessors!/ /g' temp.txt > %s_v%d.ll; rm temp.txt",ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==SEQ_VERSIONS_FLEX)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -DHAVE_ALLOCA_H=1 -O0 -S -emit-llvm v%d/%s.c -o %s_v%d.ll;sed 's/; preds = [%% . a-z A-Z 0-9 , _ !]*/ /g' %s_v%d.ll > temp.txt;sed 's/No predecessors!/ /g' temp.txt > %s_v%d.ll; rm temp.txt",ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}
	else if(bench_type==MUT_VERSIONS)
	{
		memset(command,'\0',command_size);
		sprintf(command,"clang -std=c99 -lm -O0 -S -emit-llvm -Wno-implicit-int -Wno-return-type v%d/%s.c -o %s_v%d.ll;sed 's/; preds = [%% . a-z A-Z 0-9 , _ !]*/ /g' %s_v%d.ll > temp.txt; cat temp.txt > %s_v%d.ll; rm temp.txt",ver1,source_file,source_file,ver1,source_file,ver1,source_file,ver1);
		mysystem(command,0.25);
	}

	sprintf(source_fname,"%s_v%d.ll",source_file,ver1);

	source=fopen(source_fname,"r");
	if(source==NULL)
	{
		printf("Error opening file %s\n",source_fname);
	}

	sprintf(dest_fname,"%s_v%d_new.ll",source_file,ver1);

	dest=fopen(dest_fname,"wt");
	if(dest==NULL)
	{
		printf("Error opening file %s\n",dest_fname);
	}

	aux=fopen("aux.txt","wt");
	if(dest==NULL)
	{
		printf("Error opening file aux.txt\n");
	}

	//--------------------------------------------------------------------begin remove printf() calls and generate globals--------------------------------------------------------------

	if(gettimeofday(&t23,NULL)<0) //timer0.5 on
		exit(2);

	while(!feof(source))
	{
		memset(buff,'\0',instru_buff_size);
		fgets(buff,instru_buff_size,source);

		if(mystrstr(buff,"call")>0 && mystrstr(buff,"@printf(")>0)
		{	
			if(mystrstr(buff,"= call")>0) //value returned from printf() may be used to define another variable which follows immediately [get ready!]
			{
				int i,len=strlen(buff);
				memset(ss,'\0',short_buff_size);
				len_ss=0;

				for(i=0;i<len;i++)
				{
					if(buff[i]=='%')
						break;
				}

				if(buff[i]=='%')
				{
					for(;i<len;i++)
					{	
						if(buff[i]==' ')
							break;
						else					
							ss[len_ss++]=buff[i];	
					}
						
					ss[len_ss]='\0';
					estat=1;
				}
			}

			pstat=1;
			continue;
		}
		else if(mystrstr(buff,"call")>0)
		{	
			if(mystrstr(buff,"@fprintf(")>0)
				continue;
			else if(mystrstr(buff,"@fputs(")>0)
				continue;
			else if(mystrstr(buff,"@puts(")>0)
				continue;	
			else if(mystrstr(buff,"@fputc(")>0)
				continue;			
			else if(mystrstr(buff,"@putw(")>0)
				continue;
			else if(mystrstr(buff,"@putc(")>0)
				continue;
			else if(mystrstr(buff,"@putchar(")>0)
				continue;
			else if(mystrstr(buff,"@fwrite(")>0 && mystrstr(buff,"= call")==0) //'= call' is essential. Do not discard this!
				continue;
			else if(mystrstr(buff,"@dprintf(")>0)
				continue;
			else if(mystrstr(buff,"@sprintf(")>0)
				continue;
			else if(mystrstr(buff,"@vfprintf(")>0)
				continue;
			else if(mystrstr(buff,"@vprintf(")>0)
				continue;
			else if(mystrstr(buff,"@vsprintf(")>0)
				continue;
			else if(mystrstr(buff,"@vdprintf(")>0)
				continue;
			else if(mystrstr(buff,"@vsnprintf(")>0)
				continue;					
		}

		if(estat==1)
		{
			estat=0;			
			
			if(mystrstr(buff,ss)>0) //skip (remove) the next immediate instruction where value returned by printf in used [remove it!]
				continue;			
		}

		if(mystrstr(buff,"declare")>0 && mystrstr(buff,"@printf(")>0)
			dstat=1;	

		if(mystrstr(buff,"attributes #1")>0)
			att1=1;

		if((blankline<=1 && semi<=1) || (blankline<=2 && semi<=1))
		{
			if(!(mystrstr(buff,"call")>0 && mystrstr(buff,"@printf(")>0))
				fprintf(aux,"%s",buff);
		}

		if(buff[0]=='\n')
			blankline++;
		else if(buff[0]==';')
		{
			mode=0;
			semi++;
		}
		else if(mystrstr(buff,"define ")>0 && mystrstr(buff," = ")==0)
		{
			int i=0,c=0;

			while(buff[i]!='\0')
			{
				if(buff[i]=='@')
				{
					i++;
					break;
				}

				i++;
			}

			memset(funname,'\0',short_buff_size);

			while(buff[i]!='\0')
			{
				if(buff[i]=='(')
				{
					c++;
					funname[c]='\0';
					break;
				}
				
				funname[c]=buff[i];
				c++;
				i++;	
			}

			mode=1;

		}
		else if(mode==1 && mystrstr(buff,":")>0 && mystrstr(buff,"!")==0)
		{
			int i=0,c=0;

			memset(blockname,'\0',short_buff_size);

			while(buff[i]!='\0')
			{
				if(buff[i]==':')
				{
					c++;
					blockname[c]='\0';
					break;
				}
				
				blockname[c]=buff[i];
				c++;
				i++;	
			}

			//printf("Current block: (%s,%s)\n",funname,blockname);

			memset(save,'\0',2*short_buff_size);

			if(bench_type==SEQ_VERSIONS_SED || bench_type==SEQ_VERSIONS_FLEX)
				sprintf(save,"_cs16d004_%s.%s",funname,blockname);		
			else
				sprintf(save,"%s.%s",funname,blockname);

			int len=2+strlen(save);

			fprintf(dest,"%s:\n",blockname);

			if(semi>=2)
			{		
				memset(buff,'\0',instru_buff_size);
				fgets(buff,instru_buff_size,source);

				if(mystrstr(buff,"= phi ")>0)
				{
					if(!(mystrstr(buff,"call")>0 && mystrstr(buff,"@printf(")>0))
						fprintf(dest,"%s",buff);
					
					fprintf(dest,"  %%call_%s_%s = call i32 (i8*, ...) @printf(i8* getelementptr inbounds ([%d x i8], [%d x i8]* @%s, i32 0, i32 0))\n",funname,blockname,len,len,save);
					
					total_blocks++;		
				}
				else
				{
					fprintf(dest,"  %%call_%s_%s = call i32 (i8*, ...) @printf(i8* getelementptr inbounds ([%d x i8], [%d x i8]* @%s, i32 0, i32 0))\n",funname,blockname,len,len,save);
					
					if(!(mystrstr(buff,"call")>0 && mystrstr(buff,"@printf(")>0))				
						fprintf(dest,"%s",buff);

					total_blocks++;	
				}
			}
			
			if(bench_type==SEQ_VERSIONS_SED || bench_type==SEQ_VERSIONS_FLEX)
				sprintf(save,"@_cs16d004_%s.%s = private unnamed_addr constant [%d x i8] c\"_cs16d004_%s,%s\\0A\\00\"",funname,blockname,len,funname,blockname);
			else		
				sprintf(save,"@%s.%s = private unnamed_addr constant [%d x i8] c\"%s,%s\\0A\\00\"",funname,blockname,len,funname,blockname);
	
			fprintf(aux,"%s\n",save);

			continue;
		}

		if(semi>=2)
		{
			if(!(mystrstr(buff,"call")>0 && mystrstr(buff,"@printf(")>0))
			{
				if(mystrstr(buff,"call")>0 && mystrstr(buff,"@write(")>0) //write() system call found
				{
					fprintf(dest,"%s\n",handle_sys_call_write(buff,instru_buff_size));
				}
				else		
					fprintf(dest,"%s",buff);
			}
		}

	}	
	
	//----------------------------------------------------------------------end remove printf() calls and generate globals--------------------------------------------------------------

	fprintf(aux,"\n");

	if(pstat==0)
	{
		if(dstat==0)
			fprintf(aux,"declare i32 @printf(i8*, ...) #1\n\n");

		if(att1==0)
			fprintf(aux,"attributes #1 = { \"disable-tail-calls\"=\"false\" \"less-precise-fpmad\"=\"false\" \"no-frame-pointer-elim\"=\"true\" \"no-frame-pointer-elim-non-leaf\" \"no-infs-fp-math\"=\"false\" \"no-nans-fp-math\"=\"false\" \"no-signed-zeros-fp-math\"=\"false\" \"stack-protector-buffer-size\"=\"8\" \"target-cpu\"=\"x86-64\" \"target-features\"=\"+fxsr,+mmx,+sse,+sse2,+x87\" \"unsafe-fp-math\"=\"false\" \"use-soft-float\"=\"false\" }\n\n");
	}	

	if(gettimeofday(&t24,NULL)<0) //timer0.5 off
		exit(2);

	fclose(source);
	fclose(dest);
	fclose(aux);

	if(bench_type==SEQ_VERSIONS)
	{
		sprintf(command,"cat aux.txt %s > temp;cat temp > %s;rm temp aux.txt;clang -DSTDC_HEADERS=1 -DHAVE_UNISTD_H=1 -DDIRENT=1 -DHAVE_ALLOCA_H=1 -DHAVE_CONFIG_H -I. -lm -O0 -Wno-implicit-int -Wno-return-type %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}
	else if(bench_type==SEQ_VERSIONS_GIT)
	{
		sprintf(command,"awk '!seen[$0]++' aux.txt > aux2.txt;cat aux2.txt %s > temp;cat temp > %s;rm temp aux.txt aux2.txt;clang -std=gnu99 -fgnu89-inline -fPIC -lm -O0 %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}
	else if(bench_type==SEQ_VERSIONS_SCD)
	{
		sprintf(command,"awk '!seen[$0]++' aux.txt > aux2.txt;cat aux2.txt %s > temp;cat temp > %s;rm temp aux.txt aux2.txt;clang -O0 %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}
	else if(bench_type==SEQ_VERSIONS_C4)
	{
		sprintf(command,"awk '!seen[$0]++' aux.txt > aux2.txt;cat aux2.txt %s > temp;cat temp > %s;rm temp aux.txt aux2.txt;clang -m32 -Wno-return-type -O0 %s -Wl,--no-as-needed -ldl",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}
	else if(bench_type==SEQ_VERSIONS_CF)
	{
		sprintf(command,"awk '!seen[$0]++' aux.txt > aux2.txt;cat aux2.txt %s > temp;cat temp > %s;rm temp aux.txt aux2.txt;clang -g -Wall -O0 %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}
	else if(bench_type==SEQ_VERSIONS_MLISP)
	{
		sprintf(command,"cat aux.txt %s > temp;cat temp > %s;rm temp aux.txt;clang -O0 %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}	
	else if(bench_type==SEQ_VERSIONS_GREP)
	{
		sprintf(command,"cat aux.txt %s > temp;cat temp > %s;rm temp aux.txt;clang -O0 %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}
	else if(bench_type==SEQ_VERSIONS_SED)
	{
		sprintf(command,"cat aux.txt %s > temp;cat temp > %s;rm temp aux.txt;clang -std=c99 -O0 %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}
	else if(bench_type==SEQ_VERSIONS_FLEX)
	{
		sprintf(command,"cat aux.txt %s > temp;cat temp > %s;rm temp aux.txt;clang -DHAVE_ALLOCA_H=1 -O0 %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}
	else if(bench_type==MUT_VERSIONS)
	{
		sprintf(command,"cat aux.txt %s > temp;cat temp > %s;rm temp aux.txt;clang -std=c99 -lm -O0 -Wno-implicit-int -Wno-return-type %s",dest_fname,dest_fname,dest_fname);
		mysystem(command,0.5);
	}	
}
