#include<stdio.h>
#define MAX 8
#define WHITE 1
#define GRAY 2
#define BLACK 3
#define NIL -999999
#define INF 999999
int color[MAX+1],pi[MAX+1],Q[MAX+1],d[MAX+1],qsize,rear,front;
void print_tree(int a[],int j)
{
	
	if(a[j]==NIL)
	{
		printf("%d",j);
	}
	else
	{
		print_tree(a,a[j]);
		printf("->%d",j);
	}
}
void enqueue(int s)
{
  	if((front==1&&rear==MAX)||(front==rear+1))
	{
		printf("Overflow!!");
		return;
	}
	else if(front==0)
	{
		front=1;
		rear=1;
	}
	else if(rear==MAX)
	{
		rear=1;
	}
	else
	{
		rear=rear+1;
	}
	Q[rear]=s;
}
int dequeue()
{
  	int item;

	if(front==0)
	{
		printf("Underflow!!");
		return;
	}
	
	item=Q[front];
	Q[front]=0;

	if(front==rear)
	{	
		front=0;
		rear=0;
	}
	else if(front==MAX)
	{
		front=1;
	}
	else
	{
		front=front+1;
	}
	return(item);
}  		
void bfs(int g[MAX+1][MAX+1],int s)
{
	int u,v,i;

	for(u=1;u<=MAX;u++)
	{
		if(u!=s)
		{
			color[u]=WHITE;
			d[u]=INF;
			pi[u]=NIL;
		}
	}
	color[s]=GRAY;
	d[s]=0;
	pi[s]=NIL;
	
	for(i=1;i<=MAX;Q[i]=0,i++);
	
	enqueue(s);

	while(qsize!=0)
	{
		u=dequeue();
		
		for(v=1;v<=MAX;v++)
		{
			if(g[u][v]==1)
			{
				if(color[v]==WHITE)
				{
					color[v]=GRAY;
					d[v]=d[u]+1;
					pi[v]=u;
					enqueue(v);
				}
			}
		}
		color[u]=BLACK;
		qsize--;
	}
}
int main()
{
	int i,source;
	qsize=MAX;
	front=0;
	rear=0;
	source=2;
	int g[MAX+1][MAX+1]={{0,0,0,0,0,0,0,0,0},
			     {0,0,1,0,0,0,0,0,1},
			     {0,1,0,0,0,0,0,1,0},
			     {0,0,0,0,1,0,1,1,0},
			     {0,0,0,1,0,1,0,0,0},
			     {0,0,0,0,1,0,1,0,0},
			     {0,0,0,1,0,1,0,1,0},
			     {0,0,1,1,0,0,1,0,0},
			     {0,1,0,0,0,0,0,0,0}};

	bfs(g,source);
	
	for(i=1;i<=MAX;i++)
	{
		switch(color[i])
		{
			case 1: printf("\ncolor[%d]:WHITE",i);
				break;
			case 2: printf("\ncolor[%d]:GRAY",i);
				break;
			case 3: printf("\ncolor[%d]:BLACK",i);
				break;
		}
		
	}
	printf("\n\n");
	for(i=1;i<=MAX;i++)
	{	
		if(pi[i]!=NIL)
			printf("\npi[%d]:%d",i,pi[i]);
		else
			printf("\npi[%d]:NIL",i);
	}
	printf("\n\n");
	for(i=1;i<=MAX;i++)
	{
		printf("\nd[%d]:%d",i,d[i]);
	}
	printf("\n\n");

	printf("\nThe root of the tree is %d\n",source);
	for(i=1;i<=MAX;i++)
	{
		if(pi[i]!=NIL)
		{
			printf("\nPath from %d to %d is: ",source,i);
			print_tree(pi,i);
		}
	}
	printf("\n\n\n");
	return(0);
}	
