#include<stdio.h>
#define INF 9999999
#define NIL -9999999
int max=5;
int d[5],pi[5];
void printpath(int a[5],int i)
{
	if(pi[i]==NIL)
	{
		printf("%d",i);
		return;
	}
	else
	{
		printpath(pi,pi[i]);
		printf("->%d",i);
	}
}
void display(int g[5][5])
{
	int i,j,k;
	
	printf("The weight matrix...\n\n");
	for(i=0;i<max;i++)
	{
		for(j=0;j<max;j++)
		{
			if(g[i][j]!=INF)
				printf(" %d ",g[i][j]);
			else
				printf(" INF ");
		}
		printf("\n");
	}
	printf("\nThe d list...\n");
	for(k=0;k<max;k++)
		printf("\nd[%d]:%d",k,d[k]);
	printf("\nThe pi list...\n");
	for(k=0;k<max;k++)
	{	
		if(pi[k]!=NIL)
			printf("\npi[%d]:%d",k,pi[k]);
		else		
			printf("\npi[%d]:NIL",k);
	}

}
void relax(int u,int v,int w[5][5])
{
	if(d[v]>d[u]+w[u][v])
	{
		d[v]=d[u]+w[u][v];
		pi[v]=u;
	}
}
void init_single_src(int g[5][5],int s)
{
	int v;

	for(v=0;v<max;v++)
	{
		d[v]=INF;
		pi[v]=NIL;
	}
	d[s]=0;
}
int bellman_ford(int g[5][5],int w[5][5],int s)
{
	int k,i,j;
	
	init_single_src(g,s);
	
	for(k=0;k<max-1;k++)
	{
		for(i=0;i<max;i++)
		{
			for(j=0;j<max;j++)
			{
				relax(i,j,w);
			}
		}
	}
	for(i=0;i<max;i++)
	{
		for(j=0;j<max;j++)
		{
			if(d[j]>d[i]+w[i][j])
			{
				return(0);
			}
		}
	}
	return(1);
}	
main()
{
	int w[5][5]={{0,6,INF,7,INF},
		     {INF,0,5,8,-4},
		     {INF,-2,0,INF,INF},
		     {INF,INF,-3,0,9},
	     	     {2,INF,7,INF,0}};	
	
	int status,i,source;

	source=0;
	status=bellman_ford(w,w,source);
	if(status)
		printf("Bellman Ford returned TRUE..\n\n");
	else
		printf("Bellman Ford returned FALSE..\n\n");

	display(w);
	
	for(i=0;i<max;i++)
	{
		printf("\nShortest path from source %d to %d: ",source,i);
		printpath(pi,i);
	}
	printf("\n");
}					
