#include<stdio.h>
#define INF 999999
#define NIL -999999
#define max 5
int d[max+1][max+1],pi[max+1][max+1];
void printpath(int a[max+1][max+1],int i,int j)
{
	if(i==j)
	{
		printf(" %d ",i);
	}
	else if(a[i][j]==NIL)
	{
		printf("\nNo path from %d to %d exists",i,j);
	}
	else
	{
		printpath(a,i,a[i][j]);
		printf("-> %d ",j);
	}
}
void floyd_warshall(int w[max+1][max+1])
{
	int i,j,k;

	for(i=1;i<=max;i++)
	{
		for(j=1;j<=max;j++)
		{
			d[i][j]=w[i][j];
			if(i!=j&&d[i][j]<INF)
				pi[i][j]=i;
			if(i==j||d[i][j]==INF)	
				pi[i][j]=NIL;					
		}	
	}
	
	for(k=1;k<=max;k++)
	{
		for(i=1;i<=max;i++)
		{
			for(j=1;j<=max;j++)
			{
				if(d[i][j]>d[i][k]+d[k][j])
				{
					d[i][j]=d[i][k]+d[k][j];
					pi[i][j]=pi[k][j];
				}
			}
		}
	}

	printf("The D matrix \n\n");
	
	for(i=1;i<=max;i++)
	{
		for(j=1;j<=max;j++)
		{
			printf(" %d ",d[i][j]);
		}
		printf("\n");
	}
	
	printf("The Predecesor matrix\n\n");
	
	for(i=1;i<=max;i++)
	{
		for(j=1;j<=max;j++)
		{
			if(pi[i][j]!=NIL)
				printf(" %d ",pi[i][j]);
			else
				printf("NIL");
		}
		printf("\n");
	}
	
	for(i=1;i<=max;i++)
	{
		for(j=1;j<=max;j++)
		{
			printf("\nPath from %d to %d  ",i,j);
			printpath(pi,i,j);
		}
	}
}
main()
{
	int g[max+1][max+1]={{0,0,0,0,0,0},
			     {0,0,3,8,INF,-4},
			     {0,INF,0,INF,1,7},
		 	     {0,INF,4,0,INF,INF},
			     {0,2,INF,-5,0,INF},
			     {0,INF,INF,INF,6,0}};

	floyd_warshall(g);
	printf("\n\n");
}

