#!/bin/bash

rm -f report

win_size=16
export OMP_NUM_THREADS=16
export OMP_PROC_BIND=true

bound=`cat subject/$1/numVersionPairs`;
tests=`cat subject/$1/numTests`;
mode=`cat subject/$1/inputMode`;
global_sty=$2;
prio=$3;

printf "\ntesting [$1] with $win_size-threaded parallelization windows\n";

for i in `seq 1 $bound`;
do
	printf "\n(version $i of $bound) testing [$1_v$i.c] initiated...\n";
	
	cp versions$i versions

	rm -f current_out/*

	TIMEFORMAT='cs16d004 %U shouvick %S'

	./engine $tests $mode $global_sty $prio 100.00 $win_size time$i > eval$i.rts

	printf "\n\n" >> time$i

	rm -f *.result time

	rm -f runall versions diff.txt mydiff.txt blk_limit a.out one.txt two.txt csum time *.ll *.cov exe *.selected *.result *commands.sh *commands2.sh xcommands.sh xcommands2.sh xtime

	sh calc.sh

	rm -f *.time *.rts time*

	printf "(version $i of $bound) testing [$1_v$i.c] completed\n";
done

